VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsAlign"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private m_Align As Alignment

Public Property Let Align(ByVal vData As Alignment)
    
    m_Align = vData

End Property

Public Property Get Align() As Alignment
    
    Align = m_Align

End Property

Private Sub Class_Initialize()

    m_Align = LawfulGood

End Sub

Public Property Get AlignStr() As String

    AlignStr = AlignString(m_Align)

End Property

Public Property Let AlignStr(ByVal S As String)

    m_Align = Me.GetAlignIndex(S)

End Property

Public Function GetAlignIndex(ByVal S As String) As Alignment

    Dim A As Alignment
    Dim I As Integer
    Dim Found As Boolean
    
    If Len(S) < 3 Then
        Select Case S
        Case "LG"
            A = LawfulGood
        Case "NG"
            A = NeutralGood
        Case "CG"
            A = ChaoticGood
        Case "LN"
            A = LawfulNeutral
        Case "N"
            A = TrueNeutral
        Case "CN"
            A = ChaoticNeutral
        Case "LE"
            A = LawfulEvil
        Case "NE"
            A = NeutralEvil
        Case "CE"
            A = ChaoticEvil
        Case Else
            Debug.Print ("(GetAlignIndex) Error parsing alignment string : " + S)
        End Select
        GetAlignIndex = A
    Else
        Found = False
        For I = 0 To 8
            If S = AlignString(I) Then
                A = I
                Found = True
                Exit For
            End If
        Next I
        If Found = False Then
            Debug.Print ("(GetAlignIndex) Error parsing alignment string : " + S)
        End If
        GetAlignIndex = A
        Exit Function
    End If
    
End Function
