VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsAlignDist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private m_LG As Single
Private m_NG As Single
Private m_CG As Single
Private m_LN As Single
Private m_N As Single
Private m_CN As Single
Private m_LE As Single
Private m_NE As Single
Private m_CE As Single
Private m_Law As Single
Private m_Good As Single
Private m_Coef As Integer
Private m_Uniform As Boolean
Private m_AlignAsArray As Collection

Public Property Set AlignAsArray(ByVal vData As Collection)
    
    Set m_AlignAsArray = vData

End Property

Public Property Get AlignAsArray() As Collection
    
    Set AlignAsArray = m_AlignAsArray

End Property

Public Function GetRndAlign() As clsAlign

    Dim I, tot As Single
    Dim newAlign As clsAlign
    
    I = Rnd(1) * 100
    Set newAlign = New clsAlign
    
    tot = newtown.AlignDist.LG
    If I < tot Then
        newAlign.Align = LawfulGood
    Else
        tot = tot + newtown.AlignDist.LN
        If I < tot Then
            newAlign.Align = LawfulNeutral
        Else
            tot = tot + newtown.AlignDist.LE
            If I < tot Then
                newAlign.Align = LawfulEvil
            Else
                tot = tot + newtown.AlignDist.NG
                If I < tot Then
                    newAlign.Align = NeutralGood
                Else
                    tot = tot + newtown.AlignDist.N
                    If I < tot Then
                        newAlign.Align = TrueNeutral
                    Else
                        tot = tot + newtown.AlignDist.NE
                        If I < tot Then
                            newAlign.Align = NeutralEvil
                        Else
                            tot = tot + newtown.AlignDist.CG
                            If I < tot Then
                                newAlign.Align = ChaoticGood
                            Else
                                tot = tot + newtown.AlignDist.CN
                                If I < tot Then
                                    newAlign.Align = ChaoticNeutral
                                Else
                                    newAlign.Align = ChaoticEvil
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End If
    End If
    
    Set GetRndAlign = newAlign
    Set newAlign = Nothing
    
End Function

Public Function GetRndEvilAlign() As clsAlign

    Dim LE, NE, CE, total, I As Single
    Dim A As clsAlign
    
    Set A = New clsAlign
    
    LE = m_LG + m_LN + m_LE
    NE = m_NG + m_N + m_NE
    CE = m_CG + m_CN + m_CE
    
    total = LE + NE + CE
    
    LE = LE / total
    NE = NE / total
    
    I = Rnd(1) * total
    
    If I < LE Then
        A.Align = LawfulEvil
    ElseIf I < (LE + NE) Then
        A.Align = NeutralEvil
    Else
        A.Align = ChaoticEvil
    End If
    
    Set GetRndEvilAlign = A

End Function

Private Function RandomAlignment() As Alignment

    Dim I As Integer
    
    I = Int(Rnd(1) * 100)
    
    If I < 21 Then                              '21%
        RandomAlignment = LawfulGood
    ElseIf I < 32 Then                          '10%
        RandomAlignment = NeutralGood
    ElseIf I < 38 Then                          '6%
        RandomAlignment = ChaoticGood
    ElseIf I < 60 Then                          '22%
        RandomAlignment = LawfulNeutral
    ElseIf I < 69 Then                          '10%
        RandomAlignment = TrueNeutral
    ElseIf I < 74 Then                          '5%
        RandomAlignment = ChaoticNeutral
    ElseIf I < 89 Then                          '15%
        RandomAlignment = LawfulEvil
    ElseIf I < 96 Then                          '7%
        RandomAlignment = NeutralEvil
    Else                                        '4%
        RandomAlignment = ChaoticEvil
    End If

End Function

Public Sub Rand()

    Dim I, Good, Law, div As Integer
    Dim temp As Alignment
    
    div = 5
    
    For I = 1 To div
        temp = RandomAlignment()
        If temp = 0 Or temp = 3 Or temp = 6 Then
            Law = Law + 0.5 + Rnd(1)
        ElseIf temp = 2 Or temp = 5 Or temp = 8 Then
            Law = Law - (0.5 + Rnd(1))
        End If
        If temp <= 2 Then
            Good = Good + 0.5 + Rnd(1)
        ElseIf temp >= 6 Then
            Good = Good - (0.5 + Rnd(1))
        End If
    Next I
    
    m_Uniform = True
    m_Good = 100 - (((Good / div) + 1) * 50)
    m_Law = 100 - (((Law / div) + 1) * 50)
    Call ResetAllAlign

End Sub

Public Sub ResetAllAlign()

    Dim exp, total As Single
    
    exp = m_Coef / 5
    
    m_LG = (144 - ((m_Good + 0) ^ 2 + (m_Law + 0) ^ 2) ^ 0.5) ^ exp
    total = total + m_LG
    
    m_NG = (144 - ((m_Good + 0) ^ 2 + (m_Law - 50) ^ 2) ^ 0.5) ^ exp
    total = total + m_NG
    
    m_CG = (144 - ((m_Good + 0) ^ 2 + (m_Law - 100) ^ 2) ^ 0.5) ^ exp
    total = total + m_CG
    
    m_LN = (144 - ((m_Good - 50) ^ 2 + (m_Law + 0) ^ 2) ^ 0.5) ^ exp
    total = total + m_LN
    
    m_N = (144 - ((m_Good - 50) ^ 2 + (m_Law - 50) ^ 2) ^ 0.5) ^ exp
    total = total + m_N
    
    m_CN = (144 - ((m_Good - 50) ^ 2 + (m_Law - 100) ^ 2) ^ 0.5) ^ exp
    total = total + m_CN
    
    m_LE = (144 - ((m_Good - 100) ^ 2 + (m_Law + 0) ^ 2) ^ 0.5) ^ exp
    total = total + m_LE
    
    m_NE = (144 - ((m_Good - 100) ^ 2 + (m_Law - 50) ^ 2) ^ 0.5) ^ exp
    total = total + m_NE
    
    m_CE = (144 - ((m_Good - 100) ^ 2 + (m_Law - 100) ^ 2) ^ 0.5) ^ exp
    total = total + m_CE
    
    m_LG = Int((m_LG / total) * 10000) / 100
    m_NG = Int((m_NG / total) * 10000) / 100
    m_CG = Int((m_CG / total) * 10000) / 100
    m_LN = Int((m_LN / total) * 10000) / 100
    m_N = Int((m_N / total) * 10000) / 100
    m_CN = Int((m_CN / total) * 10000) / 100
    m_LE = Int((m_LE / total) * 10000) / 100
    m_NE = Int((m_NE / total) * 10000) / 100
    m_CE = Int((m_CE / total) * 10000) / 100
    
End Sub

Public Function FindMaxDist() As Single

    Dim max As Single
    
    max = m_LG
    
    If m_NG > max Then
        max = m_NG
    End If
    
    If m_CG > max Then
        max = m_CG
    End If
    
    If m_LN > max Then
        max = m_LN
    End If
    
    If m_N > max Then
        max = m_N
    End If
    
    If m_CN > max Then
        max = m_CN
    End If
    
    If m_LE > max Then
        max = m_LE
    End If
    
    If m_NE > max Then
        max = m_NE
    End If
    
    If m_CE > max Then
        max = m_CE
    End If
    
    FindMaxDist = max

End Function

Public Property Let Uniform(ByVal vData As Boolean)
    
    m_Uniform = vData

End Property

Public Property Get Uniform() As Boolean
    
    Uniform = m_Uniform

End Property

Public Property Let Good(ByVal vData As Single)
    
    m_Good = vData

End Property

Public Property Get Good() As Single
    
    Good = m_Good

End Property

Public Property Let Law(ByVal vData As Single)
    
    m_Law = vData

End Property

Public Property Get Law() As Single
    
    Law = m_Law

End Property

Public Property Let DistCoef(ByVal vData As Integer)
    
    m_Coef = vData

End Property

Public Property Get DistCoef() As Integer
    
    DistCoef = m_Coef

End Property

Public Property Let CE(ByVal vData As Single)
    
    m_CE = vData

End Property

Public Property Get CE() As Single
    
    CE = m_CE

End Property

Public Property Let NE(ByVal vData As Single)
    
    m_NE = vData

End Property

Public Property Get NE() As Single
    
    NE = m_NE

End Property

Public Property Let LE(ByVal vData As Single)
    
    m_LE = vData

End Property

Public Property Get LE() As Single
    
    LE = m_LE

End Property

Public Property Let CN(ByVal vData As Single)
    
    m_CN = vData

End Property

Public Property Get CN() As Single
    
    CN = m_CN

End Property

Public Property Let N(ByVal vData As Single)
    
    m_N = vData

End Property

Public Property Get N() As Single
    
    N = m_N

End Property

Public Property Let LN(ByVal vData As Single)
    
    m_LN = vData

End Property

Public Property Get LN() As Single
    
    LN = m_LN

End Property

Public Property Let CG(ByVal vData As Single)
    
    m_CG = vData

End Property

Public Property Get CG() As Single
    
    CG = m_CG

End Property

Public Property Let NG(ByVal vData As Single)
    
    m_NG = vData

End Property

Public Property Get NG() As Single
    
    NG = m_NG

End Property

Public Property Let LG(ByVal vData As Single)
    
    m_LG = vData

End Property

Public Property Get LG() As Single
    
    LG = m_LG

End Property

Private Sub Class_Initialize()

    m_Coef = 8
    m_Good = 50
    m_Law = 50

End Sub
