VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsGroupSubType"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private m_GroupType As GroupTypes
Private m_SubTypeInt As Integer
Private m_SubTypeString As String

Public Function GetRndSubType(GroupType As GroupTypes) As Integer

    Dim I, J As Integer
    Dim W, S As Double
         
    m_GroupType = GroupType
 
    Select Case GroupType
    Case Mercenary:
        W = newtown.GPLimit ^ 0.45
        J = Int(Rnd(1) * 6) - 2 + newtown.SizeMod
        
        If J > 4 Then
            I = Int(Rnd(1) * 10)
        Else
            I = Int(Rnd(1) * 7)
        End If
        
        If W > 70 Then I = I + Int(Rnd(1) * 8)
        
        If W > 300 Then
            I = Int(Rnd(1) * 21)
        ElseIf W > 175 Then
            I = I + Int(Rnd(1) * 10)
        ElseIf W > 110 Then
            I = I + Int(Rnd(1) * 5)
        End If
            
        If I > 20 Then I = 20
        If I < 0 Then I = 0
    Case Default:
        I = 0
    End Select
    
    m_SubTypeInt = I
    GetRndSubType = I

End Function

Public Property Let SubTypeString(ByVal vData As String)
    
    m_SubTypeString = vData

End Property

Public Property Get SubTypeString() As String
    
    SubTypeString = m_SubTypeString

End Property

Public Property Let SubTypeInt(ByVal vData As Integer)          'default
        
    If vData < 0 Then vData = 0
    
    Select Case m_GroupType
    
    Case Mercenary:
        If vData > 20 Then vData = 20
        m_SubTypeString = MilUnitTypeString(vData)
    Case UndeadGroup:
        If vData > 12 Then vData = 12
        m_SubTypeString = AreaOfHaunting(vData)
    Case Gang:
        If vData > 9 Then vData = 9
        m_SubTypeString = GangTypeString(vData)
    End Select
    
    m_SubTypeInt = vData
    
End Property

Public Property Get SubTypeInt() As Integer                     'default
Attribute SubTypeInt.VB_UserMemId = 0
    
    SubTypeInt = m_SubTypeInt

End Property

Public Property Let GroupType(ByVal vData As GroupTypes)
    
    m_GroupType = vData

End Property

Public Property Get GroupType() As GroupTypes
    
    GroupType = m_GroupType

End Property



