VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsOrgRaceDist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private m_OrgRaceDist As OrgRacialDistribution

Public Property Let OrgRaceDist(ByVal vData As OrgRacialDistribution)
    
    m_OrgRaceDist = vData

End Property

Public Property Get OrgRaceDist() As OrgRacialDistribution
    
    OrgRaceDist = m_OrgRaceDist

End Property

Public Sub SetRndOrgRaceDist(gpType As GroupTypes, gpName As String, gpSubTypeString As String)

    Dim I As Integer
    Dim X As OrgRacialDistribution
    Dim tempR As clsRace
    
    I = Int(Rnd(1) * 100) + 1
    
    If I < 60 Then
        X = Same_As_Population
    ElseIf I < 96 Then
        Set tempR = newtown.RaceDist.GetRndRace()
        X = tempR.RaceEnum + 7
    Else
        Set tempR = newtown.RaceDist.GetRndRace()
        X = tempR.RaceEnum
    End If
    
    m_OrgRaceDist = X

End Sub

Public Function GetPluralityRace() As clsRace

    Dim tempR As clsRace
    Dim I As Integer
        
    If m_OrgRaceDist < Mostly_Dwarf Then        'all the same race
        Set tempR = New clsRace
        tempR.RaceEnum = m_OrgRaceDist
    ElseIf m_OrgRaceDist < Same_As_Population Then      'mostly the same race
        Set tempR = New clsRace
        tempR.RaceEnum = m_OrgRaceDist - 7
    ElseIf m_OrgRaceDist = Same_As_Population Then
        Set tempR = newtown.RaceDist.GetPluralityRace
    Else
        Set tempR = New clsRace
        tempR.RaceEnum = Human
        Debug.Print "Unable to parse m_OrgRaceDist in GetPluralityRace, returning Human instead"
        Debug.Print "m_OrgRaceDist = " + CStr(m_OrgRaceDist)
    End If
    
    Set GetPluralityRace = tempR

End Function

Public Function GetRndRace() As clsRace

    Dim I, J, K As Single
    Dim temp As clsRace
    
    I = Rnd(1) * 100
    K = Rnd(1)
    
    If ((m_OrgRaceDist = Same_As_Population) Or ((m_OrgRaceDist > All_Human) And (K > 0.7))) Then
        Set temp = newtown.RaceDist.GetRndRace()
    ElseIf m_OrgRaceDist > All_Human Then       'mostly 1 race
        Set temp = New clsRace
        temp.RaceEnum = m_OrgRaceDist - 7
    Else                                        'all 1 race
        Set temp = New clsRace
        temp.RaceEnum = m_OrgRaceDist
    End If
        
    Set GetRndRace = temp

End Function
