VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form frmOutput 
   Caption         =   "Choose your output options"
   ClientHeight    =   7095
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9960
   ClipControls    =   0   'False
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   354.75
   ScaleMode       =   2  'Point
   ScaleWidth      =   498
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin RichTextLib.RichTextBox rtbOutput 
      Height          =   4965
      Left            =   3825
      TabIndex        =   9
      Top             =   375
      Width           =   5715
      _ExtentX        =   10081
      _ExtentY        =   8758
      _Version        =   393217
      TextRTF         =   $"frmOutput.frx":0000
   End
   Begin VB.TextBox txtFileName 
      Height          =   315
      Left            =   150
      TabIndex        =   7
      Top             =   375
      Width           =   3090
   End
   Begin VB.FileListBox File1 
      Height          =   2040
      Left            =   150
      Pattern         =   "*.txt"
      TabIndex        =   6
      Top             =   825
      Width           =   3090
   End
   Begin VB.DirListBox Dir1 
      Height          =   1890
      Left            =   150
      TabIndex        =   5
      Top             =   3000
      Width           =   3090
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   150
      TabIndex        =   4
      Top             =   5025
      Width           =   3165
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "FINISH ->"
      Height          =   495
      Left            =   8475
      TabIndex        =   3
      ToolTipText     =   "Go on to the output options"
      Top             =   6375
      Width           =   1215
   End
   Begin VB.CommandButton cmdQuit 
      Caption         =   "QUIT"
      Height          =   495
      Left            =   225
      TabIndex        =   2
      ToolTipText     =   "Quit the program"
      Top             =   6375
      Width           =   1215
   End
   Begin VB.CommandButton cmdPrevious 
      Caption         =   "<- PREV"
      Height          =   495
      Left            =   7050
      TabIndex        =   1
      ToolTipText     =   "Return to picking town options"
      Top             =   6375
      Width           =   1215
   End
   Begin VB.Label Label3 
      Caption         =   "Preview Text"
      Height          =   240
      Left            =   6225
      TabIndex        =   10
      Top             =   150
      Width           =   990
   End
   Begin VB.Label Label2 
      Caption         =   "Label2"
      Height          =   240
      Left            =   225
      TabIndex        =   8
      Top             =   6000
      Width           =   6090
   End
   Begin VB.Label Label1 
      Caption         =   "Filename and location to save under:"
      Height          =   240
      Left            =   150
      TabIndex        =   0
      Top             =   150
      Width           =   3015
   End
End
Attribute VB_Name = "frmOutput"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim OutputPath As String

Private Sub cmdNext_Click()

    If OutputPath = "" Then
        If MsgBox("There is no filename specified.  Exit without saving new town?", vbOKCancel) = vbCancel Then
            Exit Sub
        Else
            Unload Me
            End
        End If
    Else
        Call rtbOutput.SaveFile(OutputPath)
        End
    End If

End Sub

Private Sub cmdPrevious_Click()

    frmSummary.Visible = True
    frmOutput.Visible = False

End Sub

Private Sub cmdQuit_Click()

    Dim result As Integer
    
    result = MsgBox("Are you sure you want to quit?", vbOKCancel)
    
    If result = vbOK Then
        End
    End If

End Sub

Private Sub Dir1_Change()

    File1.Path = Dir1.Path

End Sub

Private Sub Drive1_Change()

    Dir1.Path = Drive1.Drive

End Sub

Private Sub File1_Click()

    txtFileName.Text = File1.FileName

End Sub

Private Sub Form_Load()

    Dim S As String

    rtbOutput.SelAlignment = rtfCenter
    rtbOutput.Font.Name = "Arial"

    If newtown.Areas.Independent = True Then
        rtbOutput.SelFontSize = 12
        S = "The Independent " + SizeString(newtown.SizeClass) + " of" + vbCrLf
        Call AddLine(S)
        rtbOutput.SelFontSize = 18
        S = newtown.TownName + vbCrLf
        Call AddLine(S)
        rtbOutput.SelFontSize = 12
        S = vbCrLf
        Call AddLine(S)
    Else
        rtbOutput.SelFontSize = 18
        S = newtown.TownName + vbCrLf
        Call AddLine(S)
        rtbOutput.SelFontSize = 12
        S = "A " + SizeString(newtown.SizeClass) + " in <Country_Name>" + vbCrLf
        Call AddLine(S)
        S = vbCrLf
        Call AddLine(S)
    End If
    
    rtbOutput.SelAlignment = rtfLeft
    rtbOutput.SelFontSize = 10
    S = "created with: Ultimate Town Generator v. " + CStr(App.Major) + "." + CStr(App.Minor) + vbCrLf
    Call AddLine(S)
    
    rtbOutput.SelFontSize = 12
    S = vbCrLf
    Call AddLine(S)
    
    S = "Basic Stats:" + vbCrLf + vbCrLf
    Call AddLine(S)
    
    
    S = ""
    If newtown.Areas.Coastal = True Then
        S = S + "Coastal "
    End If
    If newtown.Areas.River = True Then
        S = S + "Riverside "
    End If
    If newtown.Areas.Defenses >= 3 Then
        S = S + "Walled "
    End If
    S = S + SizeString(newtown.SizeClass) + vbCrLf
    Call AddLine(S)
    S = "Population: " + CStr(newtown.Population) + vbCrLf
    Call AddLine(S)


End Sub

Private Sub AddLine(NewLine As String)

        rtbOutput.SelLength = 0
        rtbOutput.SelStart = Len(rtbOutput.Text)
        rtbOutput.SelText = NewLine

End Sub

Private Sub txtFileName_Change()

    If Right$(File1.Path, 1) = "\" Then
        OutputPath = File1.Path + txtFileName.Text
    Else
        OutputPath = File1.Path + "\" + txtFileName.Text
    End If
    
    Label2.Caption = OutputPath

End Sub
