VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsGroup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private m_GroupName As String
Private m_SizeMod As Integer
Private m_MaxLevel As Integer
Private m_MSMod As Integer
Private m_Align As clsAlign
Private m_Wealth As Long
Private m_God As String
Private m_OrgRace As clsOrgRaceDist
Private m_Leaders As Collection
Private m_Officers As Collection
Private m_Members As Collection
Private m_RelStr As Integer
Private m_StatusType As GroupStatusTypes
Private m_PowerCenter As Boolean
Private m_Type As GroupTypes
Private m_SubType As clsGroupSubType
Private m_Influence As Integer
Private m_InternOrg As InternalOrganization
Private m_OfficerCnt As Integer
Private m_LeaderCnt As Integer
Private m_MemberCnt As Integer
Private m_OfficerNote As String
Private m_LeaderNote As String
Private m_MemberNote As String

Private TempNote As String
Private SetOfficerNotes As Boolean
Private SetLeaderNotes As Boolean
Private SetMemberNotes As Boolean

Public Property Let InternOrg(ByVal vData As InternalOrganization)

    m_InternOrg = vData

End Property

Public Property Get InternOrg() As InternalOrganization

    InternOrg = m_InternOrg

End Property

Public Property Let OfficerNote(ByVal vData As String)

    m_OfficerNote = vData

End Property

Public Property Get OfficerNote() As String

    OfficerNote = m_OfficerNote

End Property

Public Property Let LeaderNote(ByVal vData As String)

    m_LeaderNote = vData

End Property

Public Property Get LeaderNote() As String

    LeaderNote = m_LeaderNote

End Property

Public Property Let MemberNote(ByVal vData As String)

    m_MemberNote = vData

End Property

Public Property Get MemberNote() As String

    MemberNote = m_MemberNote

End Property

Public Property Let OfficerCount(ByVal vData As Integer)

    m_OfficerCnt = vData

End Property

Public Property Get OfficerCount() As Integer

    OfficerCount = m_OfficerCnt

End Property

Public Property Let LeaderCount(ByVal vData As Integer)

    m_LeaderCnt = vData

End Property

Public Property Get LeaderCount() As Integer

    LeaderCount = m_LeaderCnt

End Property

Public Property Let MemberCount(ByVal vData As Integer)

    m_MemberCnt = vData

End Property

Public Property Get MemberCount() As Integer

    MemberCount = m_MemberCnt

End Property

Public Property Let Influence(ByVal vData As Integer)

    m_Influence = vData

End Property

Public Property Get Influence() As Integer

    Influence = m_Influence

End Property

Public Property Set GpSubType(ByVal vData As clsGroupSubType)
    
    Set m_SubType = vData

End Property

Public Property Get GpSubType() As clsGroupSubType
    
    Set GpSubType = m_SubType

End Property

Public Property Let gpType(ByVal vData As GroupTypes)
    
    m_Type = vData
    m_SubType.GroupType = vData

End Property

Public Property Get gpType() As GroupTypes
    
    gpType = m_Type

End Property

Public Property Let PowerCenter(ByVal vData As Boolean)
    
    newtown.PowerCenters.CountVerified = False
    m_PowerCenter = vData

End Property

Public Property Get PowerCenter() As Boolean
    
    PowerCenter = m_PowerCenter

End Property

Public Property Let StatusType(ByVal vData As GroupStatusTypes)
    
    m_StatusType = vData

End Property

Public Property Get StatusType() As GroupStatusTypes
    
    StatusType = m_StatusType

End Property

Public Property Set Members(ByVal vData As Collection)
    
    Set m_Members = vData

End Property

Public Property Get Members() As Collection
    
    Set Members = m_Members

End Property

Public Property Set Officers(ByVal vData As Collection)
    
    Set m_Officers = vData

End Property

Public Property Get Officers() As Collection
    
    Set Officers = m_Officers

End Property

Public Property Set Leaders(ByVal vData As Collection)
    
    Set m_Leaders = vData

End Property

Public Property Get Leaders() As Collection
    
    Set Leaders = m_Leaders

End Property

Public Property Set OrgRace(ByVal vData As clsOrgRaceDist)
    
    Set m_OrgRace = vData

End Property

Public Property Get OrgRace() As clsOrgRaceDist
    
    Set OrgRace = m_OrgRace

End Property

Public Property Let God(ByVal vData As String)
    
    m_God = vData

End Property

Public Property Get God() As String
    
    God = m_God

End Property

Public Property Let Wealth(ByVal vData As Long)
    
    m_Wealth = vData

End Property

Public Property Get Wealth() As Long
    
    Wealth = m_Wealth

End Property

Public Property Set Align(ByVal vData As clsAlign)
    
    Set m_Align = vData

End Property

Public Property Get Align() As clsAlign
    
    Set Align = m_Align

End Property

Public Property Let MSMod(ByVal vData As Integer)
    
    m_MSMod = vData

End Property

Public Property Get MSMod() As Integer
    
    MSMod = m_MSMod

End Property

Public Property Let MaxLevel(ByVal vData As Integer)
    
    m_MaxLevel = vData

End Property

Public Property Get MaxLevel() As Integer
    
    MaxLevel = m_MaxLevel

End Property

Public Property Let RelStr(ByVal vData As Integer)
    
    m_RelStr = vData

End Property

Public Property Get RelStr() As Integer
    
    RelStr = m_RelStr

End Property

Public Property Let SizeMod(ByVal vData As Integer)
    
    m_SizeMod = vData

End Property

Public Property Get SizeMod() As Integer
    
    SizeMod = m_SizeMod

End Property

Public Property Let GroupName(ByVal vData As String)
    
    m_GroupName = vData

End Property

Public Property Get GroupName() As String
    
    GroupName = m_GroupName

End Property

Private Sub Class_Initialize()

    m_GroupName = "Unassigned"
    m_SizeMod = 0
    m_MaxLevel = 0
    m_MSMod = 0
    Set m_Align = New clsAlign
    m_Wealth = 0
    m_God = "Unassigned"
    Set m_OrgRace = New clsOrgRaceDist
    Set m_Leaders = New Collection
    Set m_Officers = New Collection
    Set m_Members = New Collection
    m_StatusType = Official
    m_PowerCenter = False
    m_Type = Church
    m_RelStr = 0
    m_Influence = 0
    Set m_SubType = New clsGroupSubType
    m_InternOrg = Friendly_Rivalry
    m_OfficerCnt = 0
    m_LeaderCnt = 0
    m_MemberCnt = 0
    m_OfficerNote = "no officer notes assigned"
    m_LeaderNote = "no leader notes assigned"
    m_MemberNote = "no member notes assigned"
    
    SetOfficerNotes = False
    SetLeaderNotes = False
    SetMemberNotes = False
    TempNote = "no note assigned"

End Sub

Public Function GetRndOrg() As InternalOrganization

    Dim C, L, X As Integer
    Dim R As Double
    
    C = newtown.AlignDist.CG + newtown.AlignDist.CN + newtown.AlignDist.CE
    L = newtown.AlignDist.LG + newtown.AlignDist.LN + newtown.AlignDist.LE
    
    R = (Rnd(1) * 100) + 1
    
    If R < C Then               'more chaotic rnd function
        X = 8 - Int((Rnd(1) * 80) ^ 0.5)
    ElseIf R < (C + L) Then     'more lawful rnd function
        X = Int((Rnd(1) * 80) ^ 0.5)
    Else                        'neutral rnd function
        X = Int(Rnd(1) * 9)
    End If
    
    GetRndOrg = X

End Function

Private Sub ClearMembers()

    Dim I As Integer
    
    For I = m_Leaders.count To 1 Step -1
        Call m_Leaders.Remove(I)
    Next I
    
    For I = m_Officers.count To 1 Step -1
        Call m_Officers.Remove(I)
    Next I
    
    For I = m_Members.count To 1 Step -1
        Call m_Members.Remove(I)
    Next I

End Sub

Public Sub RandomizeMembers()

    Dim O, L, M, I As Integer                  'number of officers, leaders, and members
    Dim tempNPC As clsNPC

    Call ClearMembers
    
    Select Case m_Type
    Case Mayor
        Select Case newtown.SizeClass
        Case Thorp
            O = 1                                   'Officer = the mayor himself
            L = 0                                   'Leader = PC classed/leveled assistants
            M = 0                                   'Members = NPC classed assistants
            If m_SizeMod > 80 Then M = 1
        Case Hamlet
            O = 1
            L = 0
            M = 0
            If m_SizeMod > 60 Then M = 1
            If m_SizeMod > 80 Then L = 1
        Case Village
            O = 1
            L = 0
            M = 1
            If m_SizeMod < 30 Then M = 0
            If m_SizeMod > 60 Then M = 2
            If m_SizeMod > 70 Then L = 1
            If m_SizeMod > 80 Then M = 3
        Case SmallTown
            O = 1
            L = 1
            M = 2
            L = L + Int((m_SizeMod - 50) / 25)
            M = M + Int((m_SizeMod - 50) / 15)
        Case LargeTown
            O = 1
            L = 2
            M = 6
            L = L + Int((m_SizeMod - 50) / 20)
            M = M + Int((m_SizeMod - 50) / 10)
        Case SmallCity
            O = 1
            L = 4
            M = 20
            L = L + Int((m_SizeMod - 50) / 10)
            M = M + Int((m_SizeMod - 50) / 4)
        Case LargeCity
            O = 1
            L = 8
            M = 40
            L = L + Int((m_SizeMod - 50) / 5)
            M = M + Int(m_SizeMod - 50)
        Case Metropolis
            O = 1
            L = 24
            M = 100
            L = L + Int((m_SizeMod - 50) / 3)
            M = M + Int((m_SizeMod - 50) * 1.5)
        End Select
        If L < 0 Then L = 0
        If M < 0 Then M = 0

    Case TownCouncil
        Select Case newtown.SizeClass
        Case Thorp
            O = PCurve(m_SizeMod, 35, 1, 3, 2)          'Officer = Councilmen
            L = 0                                       'Leaders = PC classed/leveled assistants
            M = 0                                       'Members = NPC assistants
        Case Hamlet
            O = PCurve(m_SizeMod, 30, 1, 3, 2)
            L = PCurve(m_SizeMod, 20, 1, 0, 0)
            M = PCurve(m_SizeMod, 15, 1, 0, 0)
        Case Village
            O = PCurve(m_SizeMod, 25, 1, 4, 2)
            L = PCurve(m_SizeMod, 18, 1, 0, 0)
            M = PCurve(m_SizeMod, 8, 1, 1, 0)
        Case SmallTown
            O = PCurve(m_SizeMod, 20, 1, 4, 2)
            L = PCurve(m_SizeMod, 14, 1, 1, 0)
            M = PCurve(m_SizeMod, 6, 1, 2, 0)
        Case LargeTown
            O = PCurve(m_SizeMod, 15, 1, 5, 2)
            L = PCurve(m_SizeMod, 12, 1, 2, 0)
            M = PCurve(m_SizeMod, 5, 1, 8, 0)
        Case SmallCity
            O = PCurve(m_SizeMod, 13, 1, 5, 2)
            L = PCurve(m_SizeMod, 11, 1, 6, 0)
            M = PCurve(m_SizeMod, 4, 1, 24, 0)
        Case LargeCity
            O = PCurve(m_SizeMod, 12, 1, 6, 2)
            L = PCurve(m_SizeMod, 10, 1, 10, 0)
            M = PCurve(m_SizeMod, 4, 1, 30, 0)
        Case Metropolis
            O = PCurve(m_SizeMod, 11, 1, 6, 2)
            L = PCurve(m_SizeMod, 9, 1, 14, 0)
            M = PCurve(m_SizeMod, 2, 1, 50, 0)
        End Select
        If newtown.SizeClass - 2 > O Then O = newtown.SizeClass - 2
        If O < 2 Then O = 2
        If L < 0 Then L = 0
        If M < 0 Then M = 0
        
    Case National_Nobility
        Select Case newtown.SizeClass
        Case Thorp
            O = PCurve(m_SizeMod, 40, 5, 1, 1)              'Officer = Actual Nobles
            L = PCurve(m_SizeMod, 25, 3, 1, 0)              'Leaders = PC classed/leveled retainers
            M = PCurve(m_SizeMod, 8, 1.5, 3, 0)             'Members = NPC retainers
        Case Hamlet
            O = PCurve(m_SizeMod, 38, 5, 1, 1)
            L = PCurve(m_SizeMod, 23, 3, 1, 0)
            M = PCurve(m_SizeMod, 7, 1.5, 3, 0)
        Case Village
            O = PCurve(m_SizeMod, 36, 6, 1, 1)
            L = PCurve(m_SizeMod, 21, 3, 1, 0)
            M = PCurve(m_SizeMod, 6, 1.5, 4, 1)
        Case SmallTown
            O = PCurve(m_SizeMod, 27, 3, 1, 1)
            L = PCurve(m_SizeMod, 14, 2, 2, 1)
            M = PCurve(m_SizeMod, 6, 1.5, 4, 2)
        Case LargeTown
            O = PCurve(m_SizeMod, 20, 2, 1, 1)
            L = PCurve(m_SizeMod, 8, 1.5, 2, 1)
            M = PCurve(m_SizeMod, 4, 1.3, 6, 3)
        Case SmallCity
            O = PCurve(m_SizeMod, 16, 1.5, 2, 1)
            L = PCurve(m_SizeMod, 6, 1.4, 4, 2)
            M = PCurve(m_SizeMod, 3, 1.25, 10, 4)
        Case LargeCity
            O = PCurve(m_SizeMod, 16, 1.5, 2, 1)
            L = PCurve(m_SizeMod, 6, 1.6, 5, 2)
            M = PCurve(m_SizeMod, 5, 1.7, 10, 4)
        Case Metropolis
            O = PCurve(m_SizeMod, 16, 1.5, 2, 1)
            L = PCurve(m_SizeMod, 6, 1.6, 5, 2)
            M = PCurve(m_SizeMod, 5, 1.7, 10, 4)
        End Select
        
    Case Local_Nobility
        Select Case newtown.SizeClass
        Case Thorp
            O = PCurve(m_SizeMod, 40, 5, 1, 1)              'Officer = Nobles themselves
            L = PCurve(m_SizeMod, 25, 3, 1, 0)              'Leaders = PC classed/leveled retainers
            M = PCurve(m_SizeMod, 8, 1.5, 3, 0)             'Members = NPC retainers
        Case Hamlet
            O = PCurve(m_SizeMod, 38, 5, 1, 1)
            L = PCurve(m_SizeMod, 23, 3, 1, 0)
            M = PCurve(m_SizeMod, 7, 1.5, 3, 0)
        Case Village
            O = PCurve(m_SizeMod, 36, 6, 1, 1)
            L = PCurve(m_SizeMod, 21, 3, 1, 0)
            M = PCurve(m_SizeMod, 6, 1.5, 4, 1)
        Case SmallTown
            O = PCurve(m_SizeMod, 27, 3, 1, 1)
            L = PCurve(m_SizeMod, 14, 2, 2, 1)
            M = PCurve(m_SizeMod, 6, 1.5, 4, 2)
        Case LargeTown
            O = PCurve(m_SizeMod, 20, 2, 1, 1)
            L = PCurve(m_SizeMod, 8, 1.5, 2, 1)
            M = PCurve(m_SizeMod, 4, 1.3, 6, 3)
        Case SmallCity
            O = PCurve(m_SizeMod, 16, 1.5, 2, 1)
            L = PCurve(m_SizeMod, 6, 1.4, 4, 2)
            M = PCurve(m_SizeMod, 3, 1.25, 10, 4)
        Case LargeCity
            O = PCurve(m_SizeMod, 16, 1.5, 2, 1)
            L = PCurve(m_SizeMod, 6, 1.6, 5, 2)
            M = PCurve(m_SizeMod, 5, 1.7, 10, 4)
        Case Metropolis
            O = PCurve(m_SizeMod, 16, 1.9, 2, 1)
            L = PCurve(m_SizeMod, 6, 1.6, 5, 2)
            M = PCurve(m_SizeMod, 5, 1.7, 10, 4)
        End Select
        
    Case Church
        Select Case newtown.SizeClass
        Case Thorp
            O = PCurve(m_SizeMod, 40, 5, 0, 0)              'Officer = Clerics above 1st level
            L = PCurve(m_SizeMod, 30, 3.3, 1, 0)            'Leaders = Clerics/Adepts of 1st level
            M = PCurve(m_SizeMod, 8, 1.3, 2, 1)             'Members = Church employees
        Case Hamlet
            O = PCurve(m_SizeMod, 30, 3.5, 0, 0)
            L = PCurve(m_SizeMod, 20, 2.5, 1, 0)
            M = PCurve(m_SizeMod, 9, 1.6, 2, 1)
        Case Village
            O = PCurve(m_SizeMod, 20, 2.3, 1, 0)
            L = PCurve(m_SizeMod, 15, 2.1, 3, 1)
            M = PCurve(m_SizeMod, 7, 1.5, 6, 1)
        Case SmallTown
            O = PCurve(m_SizeMod, 20, 2.3, 2, 0)
            L = PCurve(m_SizeMod, 13, 2, 4, 1)
            M = PCurve(m_SizeMod, 7, 1.6, 7, 2)
        Case LargeTown
            O = PCurve(m_SizeMod, 20, 2.4, 3, 0)
            L = PCurve(m_SizeMod, 13, 2.1, 6, 1)
            M = PCurve(m_SizeMod, 7, 1.7, 10, 2)
        Case SmallCity
            O = PCurve(m_SizeMod, 18, 2.4, 4, 0)
            L = PCurve(m_SizeMod, 12, 2.1, 8, 1)
            M = PCurve(m_SizeMod, 6, 1.7, 14, 2)
        Case LargeCity
            O = PCurve(m_SizeMod, 15, 2.5, 6, 0)
            L = PCurve(m_SizeMod, 10, 2.2, 11, 1)
            M = PCurve(m_SizeMod, 5, 1.7, 17, 2)
        Case Metropolis
            O = PCurve(m_SizeMod, 13, 2.7, 11, 0)
            L = PCurve(m_SizeMod, 8, 2.5, 22, 1)
            M = PCurve(m_SizeMod, 4, 2.1, 33, 2)
        End Select
        
    Case National_Army
        Select Case newtown.SizeClass
        Case Thorp
            O = PCurve(m_SizeMod, 40, 3, 0, 0)              'Officer = Higher level leaders
            L = PCurve(m_SizeMod, 23, 2, 1, 1)              'Leaders = Mid level leaders
            M = PCurve(m_SizeMod, 8, 1.3, 6, 1)             'Members = Low level grunts
        Case Hamlet
            O = PCurve(m_SizeMod, 40, 3, 0, 0)
            L = PCurve(m_SizeMod, 23, 2, 1, 1)
            M = PCurve(m_SizeMod, 8, 1.3, 7, 1)
        Case Village
            O = PCurve(m_SizeMod, 40, 3, 1, 0)
            L = PCurve(m_SizeMod, 23, 2.3, 4, 1)
            M = PCurve(m_SizeMod, 8, 1.3, 25, 1)
        Case SmallTown
            O = PCurve(m_SizeMod, 36, 3, 2, 0)
            L = PCurve(m_SizeMod, 23, 2.5, 7, 1)
            M = PCurve(m_SizeMod, 8, 2.5, 50, 1)
        Case LargeTown
            O = PCurve(m_SizeMod, 29, 4.5, 4, 1)
            L = PCurve(m_SizeMod, 16, 3.5, 11, 6)
            M = PCurve(m_SizeMod, 6, 3.5, 120, 80)
        Case SmallCity
            O = PCurve(m_SizeMod, 23, 5.5, 6, 3)
            L = PCurve(m_SizeMod, 11, 3.5, 15, 12)
            M = PCurve(m_SizeMod, 5, 3.7, 160, 140)
        Case LargeCity
            O = PCurve(m_SizeMod, 20, 5.5, 6, 4)
            L = PCurve(m_SizeMod, 9, 3.8, 22, 12)
            M = PCurve(m_SizeMod, 5, 3.9, 400, 380)
        Case Metropolis
            O = PCurve(m_SizeMod, 9, 4, 20, 14)
            L = PCurve(m_SizeMod, 4, 3.7, 50, 40)
            M = PCurve(m_SizeMod, 3, 3.8, 1000, 800)
        End Select
        
    Case OccupationGuild
        Select Case newtown.SizeClass
        Case Thorp
            O = PCurve(m_SizeMod, 40, 5, 0, 0)              'Officer = Masters, guild leaders
            L = PCurve(m_SizeMod, 30, 3.3, 1, 1)            'Leaders = Journeymen
            M = PCurve(m_SizeMod, 8, 1.3, 2, 0)             'Members = Apprentices
        Case Hamlet
            O = PCurve(m_SizeMod, 30, 3.5, 0, 0)
            L = PCurve(m_SizeMod, 20, 2.5, 1, 1)
            M = PCurve(m_SizeMod, 9, 1.6, 2, 0)
        Case Village
            O = PCurve(m_SizeMod, 20, 2.3, 1, 0)
            L = PCurve(m_SizeMod, 15, 2.1, 3, 1)
            M = PCurve(m_SizeMod, 7, 1.5, 6, 1)
        Case SmallTown
            O = PCurve(m_SizeMod, 20, 2.3, 2, 0)
            L = PCurve(m_SizeMod, 13, 2, 4, 1)
            M = PCurve(m_SizeMod, 7, 1.6, 7, 2)
        Case LargeTown
            O = PCurve(m_SizeMod, 20, 2.4, 3, 0)
            L = PCurve(m_SizeMod, 13, 2.1, 6, 1)
            M = PCurve(m_SizeMod, 7, 1.7, 10, 2)
        Case SmallCity
            O = PCurve(m_SizeMod, 18, 2.4, 4, 0)
            L = PCurve(m_SizeMod, 12, 2.1, 8, 1)
            M = PCurve(m_SizeMod, 6, 1.7, 14, 2)
        Case LargeCity
            O = PCurve(m_SizeMod, 15, 2.5, 6, 0)
            L = PCurve(m_SizeMod, 10, 2.2, 11, 1)
            M = PCurve(m_SizeMod, 5, 1.7, 17, 2)
        Case Metropolis
            O = PCurve(m_SizeMod, 13, 2.7, 11, 0)
            L = PCurve(m_SizeMod, 8, 2.5, 22, 1)
            M = PCurve(m_SizeMod, 4, 2.1, 33, 2)
        End Select
        
    Case Wizard
        Select Case newtown.SizeClass
        Case Thorp
            O = PCurve(m_SizeMod, 40, 3, 1, 1)          'Officer = 2+ level wizard
            L = PCurve(m_SizeMod, 29, 2.5, 2, 0)        'Leaders = 1st level apprentices
            M = PCurve(m_SizeMod, 20, 2.2, 3, 0)        'Members = Other guys
        Case Hamlet
            O = PCurve(m_SizeMod, 32, 3, 1, 1)
            L = PCurve(m_SizeMod, 23, 2.5, 2, 0)
            M = PCurve(m_SizeMod, 16, 2.2, 3, 0)
        Case Village
            O = PCurve(m_SizeMod, 28, 3, 1, 1)
            L = PCurve(m_SizeMod, 20, 2.5, 2, 0)
            M = PCurve(m_SizeMod, 13, 2.2, 3, 0)
        Case SmallTown
            O = PCurve(m_SizeMod, 26, 3, 1, 1)
            L = PCurve(m_SizeMod, 18, 2.5, 2, 0)
            M = PCurve(m_SizeMod, 11, 2.2, 3, 0)
        Case LargeTown
            O = PCurve(m_SizeMod, 25, 3, 1, 1)
            L = PCurve(m_SizeMod, 17, 2.5, 2, 0)
            M = PCurve(m_SizeMod, 10, 2.2, 3, 0)
        Case SmallCity
            O = PCurve(m_SizeMod, 24, 3, 1, 1)
            L = PCurve(m_SizeMod, 14, 2.5, 2, 0)
            M = PCurve(m_SizeMod, 8, 2.2, 3, 0)
        Case LargeCity
            O = PCurve(m_SizeMod, 20, 3, 1, 1)
            L = PCurve(m_SizeMod, 11, 2.5, 2, 0)
            M = PCurve(m_SizeMod, 6, 2.2, 3, 0)
        Case Metropolis
            O = PCurve(m_SizeMod, 17, 3.2, 1, 1)
            L = PCurve(m_SizeMod, 8, 2.9, 2, 0)
            M = PCurve(m_SizeMod, 5, 2.6, 3, 0)
        End Select
        
    Case ExAdventurers
        Select Case newtown.SizeClass
        Case Thorp
            O = PCurve(m_SizeMod, 40, 3, 1, 1)          'Officer = PC Types
            L = PCurve(m_SizeMod, 13, 1.5, 1, 0)        'Leaders = Henchmen
            M = PCurve(m_SizeMod, 20, 2.2, 2, 0)        'Members = Hirelings/Servants
        Case Hamlet
            O = PCurve(m_SizeMod, 40, 3, 1, 1)
            L = PCurve(m_SizeMod, 13, 1.5, 1, 0)
            M = PCurve(m_SizeMod, 20, 2.2, 2, 0)
        Case Village
            O = PCurve(m_SizeMod, 23, 2#, 2, 1)
            L = PCurve(m_SizeMod, 11, 1.3, 2, 0)
            M = PCurve(m_SizeMod, 19, 2.3, 4, 0)
        Case SmallTown
            O = PCurve(m_SizeMod, 21, 2#, 2, 1)
            L = PCurve(m_SizeMod, 9, 1.3, 2, 0)
            M = PCurve(m_SizeMod, 13, 1.9, 4, 0)
        Case LargeTown
            O = PCurve(m_SizeMod, 19, 2#, 2, 1)
            L = PCurve(m_SizeMod, 8, 1.3, 2, 0)
            M = PCurve(m_SizeMod, 11, 1.9, 4, 0)
        Case SmallCity
            O = PCurve(m_SizeMod, 19, 2.2, 2, 1)
            L = PCurve(m_SizeMod, 8, 1.4, 2, 0)
            M = PCurve(m_SizeMod, 11, 2#, 4, 0)
        Case LargeCity
            O = PCurve(m_SizeMod, 19, 2.2, 3, 1)
            L = PCurve(m_SizeMod, 8, 1.4, 3, 0)
            M = PCurve(m_SizeMod, 11, 2#, 5, 0)
        Case Metropolis
            O = PCurve(m_SizeMod, 19, 2.6, 3, 1)
            L = PCurve(m_SizeMod, 8, 1.65, 4, 0)
            M = PCurve(m_SizeMod, 11, 2.2, 7, 0)
        End Select
        
    Case Thieves_Guild
        Select Case newtown.SizeClass
        Case Thorp
            O = PCurve(m_SizeMod, 40, 5, 0, 0)          'Officer = 2+ level Thieves
            L = PCurve(m_SizeMod, 30, 3.3, 1, 1)        'Leaders = 1st level guys
            M = PCurve(m_SizeMod, 8, 1.3, 2, 0)         'Members = Non-thief members/helpers/fences/tough guys
        Case Hamlet
            O = PCurve(m_SizeMod, 30, 3.5, 0, 0)
            L = PCurve(m_SizeMod, 20, 2.5, 1, 1)
            M = PCurve(m_SizeMod, 9, 1.6, 2, 0)
        Case Village
            O = PCurve(m_SizeMod, 20, 2.3, 1, 0)
            L = PCurve(m_SizeMod, 15, 2.1, 3, 1)
            M = PCurve(m_SizeMod, 7, 1.5, 6, 1)
        Case SmallTown
            O = PCurve(m_SizeMod, 20, 2.3, 2, 0)
            L = PCurve(m_SizeMod, 13, 2, 4, 1)
            M = PCurve(m_SizeMod, 7, 1.6, 7, 2)
        Case LargeTown
            O = PCurve(m_SizeMod, 20, 2.4, 3, 0)
            L = PCurve(m_SizeMod, 13, 2.1, 6, 1)
            M = PCurve(m_SizeMod, 7, 1.7, 10, 2)
        Case SmallCity
            O = PCurve(m_SizeMod, 18, 2.4, 4, 0)
            L = PCurve(m_SizeMod, 12, 2.1, 8, 1)
            M = PCurve(m_SizeMod, 6, 1.7, 14, 2)
        Case LargeCity
            O = PCurve(m_SizeMod, 15, 2.5, 6, 0)
            L = PCurve(m_SizeMod, 10, 2.2, 11, 1)
            M = PCurve(m_SizeMod, 5, 1.7, 17, 2)
        Case Metropolis
            O = PCurve(m_SizeMod, 13, 2.7, 11, 0)
            L = PCurve(m_SizeMod, 8, 2.5, 22, 1)
            M = PCurve(m_SizeMod, 4, 2.1, 33, 2)
        End Select
        
    Case Local_Army
        Select Case newtown.SizeClass
        Case Thorp
            O = PCurve(m_SizeMod, 40, 3, 0, 0)              'Officer = Higher level leaders
            L = PCurve(m_SizeMod, 23, 2, 1, 1)              'Leaders = Mid level leaders
            M = PCurve(m_SizeMod, 8, 1.3, 6, 1)             'Members = Low level grunts
        Case Hamlet
            O = PCurve(m_SizeMod, 40, 3, 0, 0)
            L = PCurve(m_SizeMod, 23, 2, 1, 1)
            M = PCurve(m_SizeMod, 8, 1.3, 7, 1)
        Case Village
            O = PCurve(m_SizeMod, 40, 3, 1, 0)
            L = PCurve(m_SizeMod, 23, 2.3, 4, 1)
            M = PCurve(m_SizeMod, 8, 1.3, 25, 1)
        Case SmallTown
            O = PCurve(m_SizeMod, 36, 3, 2, 0)
            L = PCurve(m_SizeMod, 23, 2.5, 7, 1)
            M = PCurve(m_SizeMod, 8, 2.5, 50, 1)
        Case LargeTown
            O = PCurve(m_SizeMod, 29, 4.5, 4, 1)
            L = PCurve(m_SizeMod, 16, 3.5, 11, 6)
            M = PCurve(m_SizeMod, 6, 3.5, 120, 80)
        Case SmallCity
            O = PCurve(m_SizeMod, 23, 5.5, 6, 3)
            L = PCurve(m_SizeMod, 11, 3.5, 15, 12)
            M = PCurve(m_SizeMod, 5, 3.7, 160, 140)
        Case LargeCity
            O = PCurve(m_SizeMod, 20, 5.5, 6, 4)
            L = PCurve(m_SizeMod, 9, 3.8, 22, 12)
            M = PCurve(m_SizeMod, 5, 3.9, 400, 380)
        Case Metropolis
            O = PCurve(m_SizeMod, 9, 4, 20, 14)
            L = PCurve(m_SizeMod, 4, 3.7, 50, 40)
            M = PCurve(m_SizeMod, 3, 3.8, 1000, 800)
        End Select
        
    Case Town_Guard
        Select Case newtown.SizeClass
        Case Thorp
            O = PCurve(m_SizeMod, 40, 3, 0, 0)              'Officer = Higher level leaders
            L = PCurve(m_SizeMod, 23, 2, 1, 1)              'Leaders = Mid level leaders
            M = PCurve(m_SizeMod, 8, 1.3, 6, 1)             'Members = Low level grunts
        Case Hamlet
            O = PCurve(m_SizeMod, 40, 3, 0, 0)
            L = PCurve(m_SizeMod, 23, 2, 1, 1)
            M = PCurve(m_SizeMod, 8, 1.3, 7, 1)
        Case Village
            O = PCurve(m_SizeMod, 40, 3, 1, 0)
            L = PCurve(m_SizeMod, 23, 2.3, 4, 1)
            M = PCurve(m_SizeMod, 8, 1.3, 25, 1)
        Case SmallTown
            O = PCurve(m_SizeMod, 36, 3, 2, 0)
            L = PCurve(m_SizeMod, 23, 2.5, 7, 1)
            M = PCurve(m_SizeMod, 8, 2.5, 50, 1)
        Case LargeTown
            O = PCurve(m_SizeMod, 29, 4.5, 4, 1)
            L = PCurve(m_SizeMod, 16, 3.5, 11, 6)
            M = PCurve(m_SizeMod, 6, 3.5, 120, 80)
        Case SmallCity
            O = PCurve(m_SizeMod, 23, 5.5, 6, 3)
            L = PCurve(m_SizeMod, 11, 3.5, 15, 12)
            M = PCurve(m_SizeMod, 5, 3.7, 160, 140)
        Case LargeCity
            O = PCurve(m_SizeMod, 20, 5.5, 6, 4)
            L = PCurve(m_SizeMod, 9, 3.8, 22, 12)
            M = PCurve(m_SizeMod, 5, 3.9, 400, 380)
        Case Metropolis
            O = PCurve(m_SizeMod, 9, 4, 20, 14)
            L = PCurve(m_SizeMod, 4, 3.7, 50, 40)
            M = PCurve(m_SizeMod, 3, 3.8, 1000, 800)
        End Select
        
    Case Gang
        Select Case newtown.SizeClass
        Case Thorp
            O = PCurve(m_SizeMod, 40, 5, 0, 0)          'Officer = Gang leaders/organizers/financiers
            L = PCurve(m_SizeMod, 30, 3.3, 1, 1)        'Leaders = Full members
            M = PCurve(m_SizeMod, 8, 1.3, 2, 0)         'Members = Associates/Hangers-On/Newbies
        Case Hamlet
            O = PCurve(m_SizeMod, 30, 3.5, 0, 0)
            L = PCurve(m_SizeMod, 20, 2.5, 1, 1)
            M = PCurve(m_SizeMod, 9, 1.6, 2, 0)
        Case Village
            O = PCurve(m_SizeMod, 20, 2.3, 1, 0)
            L = PCurve(m_SizeMod, 15, 2.1, 3, 1)
            M = PCurve(m_SizeMod, 7, 1.5, 6, 1)
        Case SmallTown
            O = PCurve(m_SizeMod, 20, 2.3, 2, 0)
            L = PCurve(m_SizeMod, 13, 2, 4, 1)
            M = PCurve(m_SizeMod, 7, 1.6, 7, 2)
        Case LargeTown
            O = PCurve(m_SizeMod, 20, 2.4, 3, 0)
            L = PCurve(m_SizeMod, 13, 2.1, 6, 1)
            M = PCurve(m_SizeMod, 7, 1.7, 10, 2)
        Case SmallCity
            O = PCurve(m_SizeMod, 18, 2.4, 4, 0)
            L = PCurve(m_SizeMod, 12, 2.1, 8, 1)
            M = PCurve(m_SizeMod, 6, 1.7, 14, 2)
        Case LargeCity
            O = PCurve(m_SizeMod, 15, 2.5, 6, 0)
            L = PCurve(m_SizeMod, 10, 2.2, 11, 1)
            M = PCurve(m_SizeMod, 5, 1.7, 17, 2)
        Case Metropolis
            O = PCurve(m_SizeMod, 13, 2.7, 11, 0)
            L = PCurve(m_SizeMod, 8, 2.5, 22, 1)
            M = PCurve(m_SizeMod, 4, 2.1, 33, 2)
        End Select
        
    Case Town_Militia
        Select Case newtown.SizeClass
        Case Thorp
            O = PCurve(m_SizeMod, 40, 3, 0, 0)              'Officer = Higher level leaders
            L = PCurve(m_SizeMod, 23, 2, 1, 1)              'Leaders = Mid level leaders
            M = PCurve(m_SizeMod, 8, 1.3, 6, 1)             'Members = Low level grunts
        Case Hamlet
            O = PCurve(m_SizeMod, 40, 3, 0, 0)
            L = PCurve(m_SizeMod, 23, 2, 1, 1)
            M = PCurve(m_SizeMod, 8, 1.3, 7, 1)
        Case Village
            O = PCurve(m_SizeMod, 40, 3, 1, 0)
            L = PCurve(m_SizeMod, 23, 2.3, 4, 1)
            M = PCurve(m_SizeMod, 8, 1.3, 25, 1)
        Case SmallTown
            O = PCurve(m_SizeMod, 36, 3, 2, 0)
            L = PCurve(m_SizeMod, 23, 2.5, 7, 1)
            M = PCurve(m_SizeMod, 8, 2.5, 50, 1)
        Case LargeTown
            O = PCurve(m_SizeMod, 29, 4.5, 4, 1)
            L = PCurve(m_SizeMod, 16, 3.5, 11, 6)
            M = PCurve(m_SizeMod, 6, 3.5, 120, 80)
        Case SmallCity
            O = PCurve(m_SizeMod, 23, 5.5, 6, 3)
            L = PCurve(m_SizeMod, 11, 3.5, 15, 12)
            M = PCurve(m_SizeMod, 5, 3.7, 160, 140)
        Case LargeCity
            O = PCurve(m_SizeMod, 20, 5.5, 6, 4)
            L = PCurve(m_SizeMod, 9, 3.8, 22, 12)
            M = PCurve(m_SizeMod, 5, 3.9, 400, 380)
        Case Metropolis
            O = PCurve(m_SizeMod, 9, 4, 20, 14)
            L = PCurve(m_SizeMod, 4, 3.7, 50, 40)
            M = PCurve(m_SizeMod, 3, 3.8, 1000, 800)
        End Select
        
    Case Mercenary
        Select Case newtown.SizeClass
        Case Thorp
            O = PCurve(m_SizeMod, 40, 3, 0, 0)              'Officer = Higher level leaders
            L = PCurve(m_SizeMod, 23, 2, 1, 1)              'Leaders = Mid level leaders
            M = PCurve(m_SizeMod, 8, 1.3, 6, 1)             'Members = Low level grunts
        Case Hamlet
            O = PCurve(m_SizeMod, 40, 3, 0, 0)
            L = PCurve(m_SizeMod, 23, 2, 1, 1)
            M = PCurve(m_SizeMod, 8, 1.3, 7, 1)
        Case Village
            O = PCurve(m_SizeMod, 40, 3, 1, 0)
            L = PCurve(m_SizeMod, 23, 2.3, 4, 1)
            M = PCurve(m_SizeMod, 8, 1.3, 25, 1)
        Case SmallTown
            O = PCurve(m_SizeMod, 36, 3, 2, 0)
            L = PCurve(m_SizeMod, 23, 2.5, 7, 1)
            M = PCurve(m_SizeMod, 8, 2.5, 50, 1)
        Case LargeTown
            O = PCurve(m_SizeMod, 29, 4.5, 4, 1)
            L = PCurve(m_SizeMod, 16, 3.5, 11, 6)
            M = PCurve(m_SizeMod, 6, 3.5, 120, 80)
        Case SmallCity
            O = PCurve(m_SizeMod, 23, 5.5, 6, 3)
            L = PCurve(m_SizeMod, 11, 3.5, 15, 12)
            M = PCurve(m_SizeMod, 5, 3.7, 160, 140)
        Case LargeCity
            O = PCurve(m_SizeMod, 20, 5.5, 6, 4)
            L = PCurve(m_SizeMod, 9, 3.8, 22, 12)
            M = PCurve(m_SizeMod, 5, 3.9, 400, 380)
        Case Metropolis
            O = PCurve(m_SizeMod, 9, 4, 20, 14)
            L = PCurve(m_SizeMod, 4, 3.7, 50, 40)
            M = PCurve(m_SizeMod, 3, 3.8, 1000, 800)
        End Select
        
    Case OccupationNonGuild
        Select Case newtown.SizeClass
        Case Thorp
            O = PCurve(m_SizeMod, 40, 5, 0, 0)              'Officer = Masters, Occupation Heavy Weights
            L = PCurve(m_SizeMod, 30, 3.3, 1, 1)            'Leaders = Professionals
            M = PCurve(m_SizeMod, 8, 1.3, 2, 0)             'Members = Workers
        Case Hamlet
            O = PCurve(m_SizeMod, 30, 3.5, 0, 0)
            L = PCurve(m_SizeMod, 20, 2.5, 1, 1)
            M = PCurve(m_SizeMod, 9, 1.6, 2, 0)
        Case Village
            O = PCurve(m_SizeMod, 20, 2.3, 1, 0)
            L = PCurve(m_SizeMod, 15, 2.1, 3, 1)
            M = PCurve(m_SizeMod, 7, 1.5, 6, 1)
        Case SmallTown
            O = PCurve(m_SizeMod, 20, 2.3, 2, 0)
            L = PCurve(m_SizeMod, 13, 2, 4, 1)
            M = PCurve(m_SizeMod, 7, 1.6, 7, 2)
        Case LargeTown
            O = PCurve(m_SizeMod, 20, 2.4, 3, 0)
            L = PCurve(m_SizeMod, 13, 2.1, 6, 1)
            M = PCurve(m_SizeMod, 7, 1.7, 10, 2)
        Case SmallCity
            O = PCurve(m_SizeMod, 18, 2.4, 4, 0)
            L = PCurve(m_SizeMod, 12, 2.1, 8, 1)
            M = PCurve(m_SizeMod, 6, 1.7, 14, 2)
        Case LargeCity
            O = PCurve(m_SizeMod, 15, 2.5, 6, 0)
            L = PCurve(m_SizeMod, 10, 2.2, 11, 1)
            M = PCurve(m_SizeMod, 5, 1.7, 17, 2)
        Case Metropolis
            O = PCurve(m_SizeMod, 13, 2.7, 11, 0)
            L = PCurve(m_SizeMod, 8, 2.5, 22, 1)
            M = PCurve(m_SizeMod, 4, 2.1, 33, 2)
        End Select
        
    Case Monster
        Select Case newtown.SizeClass
        Case Thorp
            O = 1                                   'Officer = the Monster itself
            L = 0                                   'Leader = Lesser Monsters
            M = 0                                   'Members = Young/Weak Monsters
            If m_SizeMod > 80 Then M = 1
        Case Hamlet
            O = 1
            L = 0
            M = 0
            If m_SizeMod > 60 Then M = 1
            If m_SizeMod > 80 Then L = 1
        Case Village
            O = 1
            L = 0
            M = 1
            If m_SizeMod < 30 Then M = 0
            If m_SizeMod > 60 Then M = 2
            If m_SizeMod > 70 Then L = 1
            If m_SizeMod > 80 Then M = 3
        Case SmallTown
            O = 1
            L = 1
            M = 2
            L = L + Int((m_SizeMod - 50) / 25)
            M = M + Int((m_SizeMod - 50) / 15)
        Case LargeTown
            O = 1
            L = 2
            M = 6
            L = L + Int((m_SizeMod - 50) / 20)
            M = M + Int((m_SizeMod - 50) / 10)
        Case SmallCity
            O = 1
            L = 4
            M = 20
            L = L + Int((m_SizeMod - 50) / 10)
            M = M + Int((m_SizeMod - 50) / 4)
        Case LargeCity
            O = 1
            L = 8
            M = 40
            L = L + Int((m_SizeMod - 50) / 5)
            M = M + Int(m_SizeMod - 50)
        Case Metropolis
            O = 1
            L = 24
            M = 100
            L = L + Int((m_SizeMod - 50) / 3)
            M = M + Int((m_SizeMod - 50) * 1.5)
        End Select
        If L < 0 Then L = 0
        If M < 0 Then M = 0
        
    Case UndeadGroup
        Select Case newtown.SizeClass
        Case Thorp
            O = PCurve(m_SizeMod, 40, 3, 1, 1)          'Officer = Major Undead
            L = PCurve(m_SizeMod, 13, 1.5, 1, 0)        'Leaders = Mediocre Undead
            M = PCurve(m_SizeMod, 20, 2.2, 2, 0)        'Members = Minor Undead
        Case Hamlet
            O = PCurve(m_SizeMod, 40, 3, 1, 1)
            L = PCurve(m_SizeMod, 13, 1.5, 1, 0)
            M = PCurve(m_SizeMod, 20, 2.2, 2, 0)
        Case Village
            O = PCurve(m_SizeMod, 23, 2#, 2, 1)
            L = PCurve(m_SizeMod, 11, 1.3, 2, 0)
            M = PCurve(m_SizeMod, 19, 2.3, 4, 0)
        Case SmallTown
            O = PCurve(m_SizeMod, 21, 2#, 2, 1)
            L = PCurve(m_SizeMod, 9, 1.3, 2, 0)
            M = PCurve(m_SizeMod, 13, 1.9, 4, 0)
        Case LargeTown
            O = PCurve(m_SizeMod, 19, 2#, 2, 1)
            L = PCurve(m_SizeMod, 8, 1.3, 2, 0)
            M = PCurve(m_SizeMod, 11, 1.9, 4, 0)
        Case SmallCity
            O = PCurve(m_SizeMod, 19, 2.2, 2, 1)
            L = PCurve(m_SizeMod, 8, 1.4, 2, 0)
            M = PCurve(m_SizeMod, 11, 2#, 4, 0)
        Case LargeCity
            O = PCurve(m_SizeMod, 19, 2.2, 3, 1)
            L = PCurve(m_SizeMod, 8, 1.4, 3, 0)
            M = PCurve(m_SizeMod, 11, 2#, 45, 0)
        Case Metropolis
            O = PCurve(m_SizeMod, 19, 2.6, 3, 1)
            L = PCurve(m_SizeMod, 8, 1.65, 4, 0)
            M = PCurve(m_SizeMod, 11, 2.2, 7, 0)
        End Select
        
    End Select
        
    m_OfficerCnt = O
    m_LeaderCnt = L
    m_MemberCnt = M
    
    'call group naming function here
    m_GroupName = "Unassigned"
        
    If O > 0 Then
        'Create the group's officers
        For I = 1 To O
            Set tempNPC = New clsNPC
            Call RandomizeOfficer(tempNPC, I)
            Call m_Officers.Add(tempNPC)
            Set tempNPC = Nothing
        Next I
    End If
    
    If L > 0 Then
        'Create the group's leaders
        For I = 1 To L
            Set tempNPC = New clsNPC
            Call RandomizeLeader(tempNPC, I)
            Call m_Leaders.Add(tempNPC)
            Set tempNPC = Nothing
        Next I
    End If
    
    If M > 0 Then
        'Create the group's members
        For I = 1 To M
            Set tempNPC = New clsNPC
            Call RandomizeMember(tempNPC, I)
            Call m_Members.Add(tempNPC)
            Set tempNPC = Nothing
        Next I
    End If

    'Debug.Print "RandomizeMembers: Type=" & PCTypeString(m_Type + 1) & "  m_SizeMod=" & CStr(m_SizeMod) & "  Officers=" & CStr(O) & "  Leaders=" & CStr(L) & "  Members=" & CStr(M)

End Sub

Private Function PCurve(Num As Integer, div As Double, exp As Double, Add As Integer, Min As Integer) As Integer

    Dim A, C As Double
    
    C = (Num - 50) / div

    If C > 0 Then
        A = Abs(C) ^ exp
    Else
        A = (1 - (Num / 50)) * (Add * -1)
    End If
        
    A = A + Add
    
    If A < Min Then A = Min
    
    PCurve = A

End Function

Public Sub RandomizePersonality(Dude As clsNPC)

    Dim A As Alignment
    Dim base, M As Integer
    Dim modifier, temp As Double
    
    A = m_Align.Align
    
    'Neutral Traits
    'Idealism    consciously tries to uphold alignment? 0=Never 10=Always
    M = Int(((Rnd(1) * 11) + (Rnd(1) * 11)) / 2)
    Dude.Personality.Idealism = M
    'Lust        lusty?  0=neutered 5=norm 10=humps anything with 2 legs
    Dude.Personality.Lust = Int(((Rnd(1) * 11) + (Rnd(1) * 11)) / 2)
    
    'Good Traits
    'Honesty     lies a lot?  0=AlwaysLies 5=Normal 10=SuperHonest
    temp = Int(Rnd(1) * 100) + 1
    If A < 3 Then
        base = 5 + (M / 2)
    ElseIf A < 6 Then base = 5
    Else: base = 5 - ((10 - M) / 2)
    End If
    If temp >= 95 Then
        base = base + 2
    ElseIf temp >= 66 Then
        base = base + 1
    ElseIf temp <= 5 Then
        base = base - 2
    ElseIf temp <= 33 Then
        base = base - 1
    End If
    If base > 10 Then base = 10
    If base < 0 Then base = 0
    Dude.Personality.Honesty = base
    'Helpful     nice to strangers?  0=Never 5=Normal 10=MotherTheresa
    temp = Int(Rnd(1) * 100) + 1
    If A < 3 Then
        base = 6 + (M / 2)
    ElseIf A < 6 Then base = 5
    Else: base = 4 - ((10 - M) / 2)
    End If
    If temp >= 95 Then
        base = base + 2
    ElseIf temp >= 66 Then
        base = base + 1
    ElseIf temp <= 5 Then
        base = base - 2
    ElseIf temp <= 33 Then
        base = base - 1
    End If
    If base > 10 Then base = 10
    If base < 0 Then base = 0
    Dude.Personality.Helpful = base
    
    'Evil Traits
    'Grudge      holds grudges?  0=Never 5=Normal 10=Remembers every slight
    temp = Int(Rnd(1) * 100) + 1
    If A > 5 Then
        base = 7
    ElseIf A > 2 Then
        base = 5
    Else
        base = 4
    End If
    If Dude.Race.RaceEnum = Dwarf Or Dude.Race.RaceEnum = Elf Then temp = temp + 3
    If Dude.Race.RaceEnum = Halfling Then temp = temp - 3
    If temp > 95 Then
        base = base + 3
    ElseIf temp > 85 Then
        base = base + 2
    ElseIf temp > 65 Then
        base = base + 1
    ElseIf temp < 5 Then
        base = base - 3
    ElseIf temp < 15 Then
        base = base - 2
    ElseIf temp < 35 Then
        base = base - 1
    End If
    If base > 10 Then base = 10
    If base < 0 Then base = 0
    Dude.Personality.Grudge = base
    'Racist      Racist?  0=Never 5=Normal 10=Hates anyone not like himself
    temp = Int(Rnd(1) * 100) + 1
    If A > 5 Then
        base = 6
    ElseIf A > 2 Then
        base = 5
    Else
        base = 3
    End If
    If Dude.Race.RaceEnum = Dwarf Or Dude.Race.RaceEnum = Elf Then temp = temp + 8
    If Dude.Race.RaceEnum = HalfElf Then temp = temp - 10
    If Dude.Race.RaceEnum = Halfling Then temp = temp - 5
    If temp > 95 Then
        base = base + 3
    ElseIf temp > 85 Then
        base = base + 2
    ElseIf temp > 65 Then
        base = base + 1
    ElseIf temp < 5 Then
        base = base - 3
    ElseIf temp < 15 Then
        base = base - 2
    ElseIf temp < 35 Then
        base = base - 1
    End If
    If base > 10 Then base = 10
    If base < 0 Then base = 0
    Dude.Personality.Racist = base
    'Temper      quick to anger?  0=BudhistMonk 5=Normal 10=Psycho
    temp = Int(Rnd(1) * 100) + 1
    If A > 5 Then
        base = 7
    ElseIf A > 2 Then
        base = 5
    Else
        base = 4
    End If
    If Dude.Race.RaceEnum = HalfOrc Then temp = temp + 15
    If Dude.Race.RaceEnum = Dwarf Then temp = temp + 10
    If Dude.Race.RaceEnum = Gnome Then temp = temp - 5
    If Dude.Race.RaceEnum = Halfling Then temp = temp - 10
    If temp > 95 Then
        base = base + 3
    ElseIf temp > 85 Then
        base = base + 2
    ElseIf temp > 65 Then
        base = base + 1
    ElseIf temp < 5 Then
        base = base - 3
    ElseIf temp < 15 Then
        base = base - 2
    ElseIf temp < 35 Then
        base = base - 1
    End If
    If base > 10 Then base = 10
    If base < 0 Then base = 0
    Dude.Personality.Temper = base
    'Greed       materialistic?  0=monk 5=normal 10=will kill for copper pieces
    temp = Int(Rnd(1) * 100) + 1
    If A > 5 Then
        base = 7
    ElseIf A > 2 Then
        base = 5
    Else
        base = 4
    End If
    If Dude.Race.RaceEnum = HalfOrc Then temp = temp + 5
    If Dude.Race.RaceEnum = Dwarf Then temp = temp + 15
    If Dude.Race.RaceEnum = Gnome Then temp = temp + 10
    If Dude.Race.RaceEnum = Halfling Then temp = temp - 5
    If Dude.Race.RaceEnum = Elf Then temp = temp - 3
    If temp > 95 Then
        base = base + 3
    ElseIf temp > 85 Then
        base = base + 2
    ElseIf temp > 65 Then
        base = base + 1
    ElseIf temp < 5 Then
        base = base - 3
    ElseIf temp < 15 Then
        base = base - 2
    ElseIf temp < 35 Then
        base = base - 1
    End If
    If base > 10 Then base = 10
    If base < 0 Then base = 0
    Dude.Personality.Greed = base
    
    'Lawful Traits
    'Trust       trusts others?  0=NeverTrusts 5=Normal 10=AlwaysTrusts
    temp = Int(Rnd(1) * 100) + 1
    If A = LawfulGood Or A = LawfulNeutral Then base = 7
    If A = NeutralGood Then
        base = 6
    ElseIf A = LawfulEvil Or A = TrueNeutral Or A = ChaoticGood Then
        base = 5
    ElseIf A = NeutralEvil Or A = ChaoticNeutral Then
        base = 4
    Else
        base = 3      'chaotic evil only
    End If
    If Dude.Race.RaceEnum = HalfOrc Then temp = temp - 4
    If Dude.Race.RaceEnum = Dwarf Then temp = temp - 4
    If Dude.Race.RaceEnum = Halfling Then temp = temp + 2
    If Dude.Race.RaceEnum = Elf Then temp = temp - 3
    If temp > 95 Then
        base = base + 3
    ElseIf temp > 85 Then
        base = base + 2
    ElseIf temp > 65 Then
        base = base + 1
    ElseIf temp < 5 Then
        base = base - 3
    ElseIf temp < 15 Then
        base = base - 2
    ElseIf temp < 35 Then
        base = base - 1
    End If
    If base > 10 Then base = 10
    If base < 0 Then base = 0
    Dude.Personality.Trust = base
    'Work        work ethic?  0=None 5=Normal 10=MrPerfect
    temp = Int(Rnd(1) * 100) + 1
    If A = LawfulGood Or A = LawfulNeutral Then base = 7
    If A = NeutralGood Then
        base = 6
    ElseIf A = LawfulEvil Or A = TrueNeutral Or A = ChaoticGood Then
        base = 5
    ElseIf A = NeutralEvil Or A = ChaoticNeutral Then
        base = 4
    Else
        base = 3      'chaotic evil only
    End If
    If Dude.Race.RaceEnum = HalfOrc Then temp = temp - 10
    If Dude.Race.RaceEnum = Dwarf Then temp = temp + 10
    If Dude.Race.RaceEnum = Halfling Then temp = temp + 5
    If Dude.Race.RaceEnum = Gnome Then temp = temp + 5
    If Dude.Race.RaceEnum = Elf Then temp = temp - 3
    If temp > 95 Then
        base = base + 3
    ElseIf temp > 85 Then
        base = base + 2
    ElseIf temp > 65 Then
        base = base + 1
    ElseIf temp < 5 Then
        base = base - 3
    ElseIf temp < 15 Then
        base = base - 2
    ElseIf temp < 35 Then
        base = base - 1
    End If
    If base > 10 Then base = 10
    If base < 0 Then base = 0
    Dude.Personality.Work = base
    'Patience    patient?  0=None 5=Normal 10=Like a brick wall
    temp = Int(Rnd(1) * 100) + 1
    If A = LawfulGood Or A = LawfulNeutral Then base = 7
    If A = NeutralGood Then
        base = 6
    ElseIf A = LawfulEvil Or A = TrueNeutral Or A = ChaoticGood Then
        base = 5
    ElseIf A = NeutralEvil Or A = ChaoticNeutral Then
        base = 4
    Else
        base = 3      'chaotic evil only
    End If
    If Dude.Race.RaceEnum = HalfOrc Then temp = temp - 10
    If Dude.Race.RaceEnum = Dwarf Then temp = temp - 10
    If Dude.Race.RaceEnum = Halfling Then temp = temp + 5
    If Dude.Race.RaceEnum = Gnome Then temp = temp + 5
    If Dude.Race.RaceEnum = Elf Then temp = temp + 5
    If temp > 95 Then
        base = base + 3
    ElseIf temp > 85 Then
        base = base + 2
    ElseIf temp > 65 Then
        base = base + 1
    ElseIf temp < 5 Then
        base = base - 3
    ElseIf temp < 15 Then
        base = base - 2
    ElseIf temp < 35 Then
        base = base - 1
    End If
    If base > 10 Then base = 10
    If base < 0 Then base = 0
    Dude.Personality.Patience = base
    
    'Chaotic Traits
    'Impulse     impulsive?  0=LikeASloth 5=Normal 10=SuperImpulsive
    temp = Int(Rnd(1) * 100) + 1
    If A = LawfulGood Or A = LawfulNeutral Then base = 3
    If A = NeutralGood Then
        base = 4
    ElseIf A = LawfulEvil Or A = TrueNeutral Or A = ChaoticGood Then
        base = 5
    ElseIf A = NeutralEvil Or A = ChaoticNeutral Then
        base = 6
    Else
        base = 7      'chaotic evil only
    End If
    If Dude.Race.RaceEnum = HalfOrc Then temp = temp + 10
    If Dude.Race.RaceEnum = Dwarf Then temp = temp + 5
    If Dude.Race.RaceEnum = Halfling Then temp = temp - 10
    If Dude.Race.RaceEnum = Gnome Then temp = temp - 6
    If Dude.Race.RaceEnum = Elf Then temp = temp - 3
    If temp > 95 Then
        base = base + 3
    ElseIf temp > 85 Then
        base = base + 2
    ElseIf temp > 65 Then
        base = base + 1
    ElseIf temp < 5 Then
        base = base - 3
    ElseIf temp < 15 Then
        base = base - 2
    ElseIf temp < 35 Then
        base = base - 1
    End If
    If base > 10 Then base = 10
    If base < 0 Then base = 0
    Dude.Personality.Impulse = base

End Sub

Public Function GetRndBaseClass(ByVal Arcane As Double, ByVal Brawl As Double) As String

    Dim temp As String
    
    If Arcane > 0.5 Then
        If Brawl > 0.5 Then
            temp = "Rogue"
        Else
            temp = "Wizard"
        End If
    Else
        If Brawl > 0.5 Then
            temp = "Fighter"
        Else
            temp = "Cleric"
        End If
    End If

    GetRndBaseClass = temp

End Function

Public Function GetCharClass(ByVal Arcane As Double, ByVal Brawl As Double, ByVal MemType As MemberType) As String

    Dim temp As String

    Select Case m_Type
    Case Mayor
        If MemType = Officer Then
            TempNote = "The Mayor himself"
            If Arcane > 0.7 Then
                If Brawl > 0.4 Then
                    temp = "Rogue"
                Else
                    temp = "Wizard"
                End If
            Else
                If Brawl > 0.5 Then
                    temp = "Aristocrat"
                ElseIf Brawl > 0.25 Then
                    temp = "Fighter"
                Else
                    temp = "Cleric"
                End If
            End If
        ElseIf MemType = Leader Then
            TempNote = "PC classed/leveled assistants"
            temp = GetRndBaseClass(Arcane, Brawl)
        Else            'Member
            TempNote = "NPC classed assistants"
            If Arcane > 0.2 Then
                If Brawl > 0.7 Then
                    temp = "Warrior"
                ElseIf Brawl > 0.5 Then
                    temp = "Aristocrat"
                ElseIf Brawl > 0.3 Then
                    temp = "Expert"
                Else
                    temp = "Commoner"
                End If
            ElseIf Arcane > 0.1 Then
                temp = GetRndBaseClass(Arcane, Brawl)
            Else
                temp = "Adept"
            End If
        End If
    Case TownCouncil
        If MemType = Officer Then
            TempNote = "The Councilmen"
        ElseIf MemType = Leader Then
            TempNote = "PC classed/leveled assistants"
        Else
            TempNote = "NPC assistants"
        End If
        If Arcane > 0.7 Then
            If Brawl > 0.4 Then
                temp = "Rogue"
            Else
                temp = "Wizard"
            End If
        Else
            If Brawl > 0.5 Then
                temp = "Aristocrat"
            ElseIf Brawl > 0.25 Then
                temp = "Fighter"
            Else
                temp = "Cleric"
            End If
        End If
    Case National_Nobility
        If MemType = Officer Then
            TempNote = "The Nobles"
        ElseIf MemType = Leader Then
            TempNote = "PC classed retainers"
        Else
            TempNote = "NPC classed retainers"
        End If
        If Arcane > 0.8 Then
            If Brawl > 0.5 Then
                temp = "Rogue"
            Else
                temp = "Wizard"
            End If
        Else
            If Brawl > 0.5 Then
                temp = "Aristocrat"
            ElseIf Brawl > 0.1 Then
                temp = "Fighter"
            Else
                temp = "Cleric"
            End If
        End If
    Case Local_Nobility
        If MemType = Officer Then
            TempNote = "The Local Noblility"
        ElseIf MemType = Leader Then
            TempNote = "PC classed retainers"
        Else
            TempNote = "NPC classed retainers"
        End If
        If Arcane > 0.8 Then
            If Brawl > 0.5 Then
                temp = "Rogue"
            Else
                temp = "Wizard"
            End If
        Else
            If Brawl > 0.5 Then
                temp = "Aristocrat"
            ElseIf Brawl > 0.1 Then
                temp = "Fighter"
            Else
                temp = "Cleric"
            End If
        End If
    Case Church
        If MemType = Officer Then
            TempNote = "The Clerical Leadership"
        ElseIf MemType = Leader Then
            TempNote = "Clerical Alcolytes"
        Else
            TempNote = "Church Employees/Retainers"
        End If
        If MemType = Officer Then
            temp = "Cleric"
        ElseIf MemType = Leader Then
            If Arcane > 0.4 Then
                temp = "Cleric"
            Else
                temp = "Adept"
            End If
        Else        'Member
            If Brawl > 0.3 Then
                temp = "Fighter"
            Else
                If Arcane > 0.5 Then
                    temp = "Wizard"
                Else
                    temp = "Rogue"
                End If
            End If
        End If
    Case National_Army
        If MemType = Officer Then
            TempNote = "The Commanders"
        ElseIf MemType = Leader Then
            TempNote = "Lower Leadership"
        Else
            TempNote = "The Grunts"
        End If
        If MemType = Officer Then
            If Arcane > 0.9 Then
                If Brawl > 0.8 Then
                    temp = "Rogue"
                Else
                    temp = "Wizard"
                End If
            Else
                If Brawl > 0.1 Then
                    temp = "Fighter"
                Else
                    temp = "Cleric"
                End If
            End If
        ElseIf MemType = Leader Then
            temp = "Fighter"
        Else        'Member
            If Brawl > 0.9 Then
                temp = "Fighter"
            Else
                temp = "Warrior"
            End If
        End If
    Case OccupationGuild
        If MemType = Officer Then
            TempNote = "Masters (Guild Leadership)"
        ElseIf MemType = Leader Then
            TempNote = "Masters"
        Else
            TempNote = "Journeymen/Apprentices"
        End If
        If MemType = Officer Then
            If Arcane > 0.7 Then
                If Brawl > 0.6 Then
                    temp = "Rogue"
                ElseIf Brawl > 0.1 Then
                    temp = "Aristocrat"
                Else
                    temp = "Commoner"
                End If
            Else
                temp = "Expert"
            End If
        ElseIf MemType = Leader Then
            If Arcane > 0.1 Then
                temp = "Expert"
            Else
                temp = "Commoner"
            End If
        Else
            If Brawl > 0.2 Then
                temp = "Expert"
            Else
                temp = "Commoner"
            End If
        End If
    Case Wizard
        If MemType = Officer Then
            TempNote = "Masters"
        ElseIf MemType = Leader Then
            TempNote = "Apprentices"
        Else
            TempNote = "Henchmen/Hirelings"
        End If
        If MemType = Officer Then
            temp = "Wizard"
        ElseIf MemType = Leader Then
            temp = "Wizard"
        Else            'Member
            If Arcane > 0.66 Then
                temp = "Rogue"
            Else
                If Brawl > 0.5 Then
                    temp = "Fighter"
                Else
                    temp = "Cleric"
                End If
            End If
        End If
    Case ExAdventurers
        If MemType = Officer Then
            TempNote = "The ex-adventurers"
        ElseIf MemType = Leader Then
            TempNote = "Their henchmen"
        Else
            TempNote = "Hirelings/Servants"
        End If
        temp = GetRndBaseClass(Arcane, Brawl)
    Case Thieves_Guild
        If MemType = Officer Then
            TempNote = "Leaders and Experienced Theives"
        ElseIf MemType = Leader Then
            TempNote = "Beginner Theives"
        Else
            TempNote = "Non-thief members"
        End If
        If MemType = Officer Or Leader Then
            temp = "Rogue"
        Else            'Members
            If Arcane > 0.66 Then
                temp = "Wizard"
            Else
                If Brawl > 0.5 Then
                    temp = "Fighter"
                Else
                    temp = "Cleric"
                End If
            End If
        End If
    Case Local_Army
        If MemType = Officer Then
            TempNote = "The Commanders"
        ElseIf MemType = Leader Then
            TempNote = "Lower Leadership"
        Else
            TempNote = "The Grunts"
        End If
        If MemType = Officer Then
            If Arcane > 0.9 Then
                If Brawl > 0.8 Then
                    temp = "Rogue"
                Else
                    temp = "Wizard"
                End If
            Else
                If Brawl > 0.1 Then
                    temp = "Fighter"
                Else
                    temp = "Cleric"
                End If
            End If
        ElseIf MemType = Leader Then
            temp = "Fighter"
        Else        'Member
            If Brawl > 0.4 Then
                temp = "Fighter"
            Else
                temp = "Warrior"
            End If
        End If
    Case Town_Guard
        If MemType = Officer Then
            TempNote = "The Commanders"
        ElseIf MemType = Leader Then
            TempNote = "Lower Leadership"
        Else
            TempNote = "The Grunts"
        End If
        If MemType = Officer Then
            If Arcane > 0.95 Then
                If Brawl > 0.8 Then
                    temp = "Rogue"
                Else
                    temp = "Wizard"
                End If
            Else
                If Brawl > 0.2 Then
                    temp = "Fighter"
                ElseIf Brawl > 0.05 Then
                    temp = "Aristocrat"
                Else
                    temp = "Cleric"
                End If
            End If
        ElseIf MemType = Leader Then
            temp = "Fighter"
        Else        'Member
            If Brawl > 0.6 Then
                temp = "Fighter"
            Else
                temp = "Warrior"
            End If
        End If
    Case Gang
        If MemType = Officer Then
            TempNote = "The Leaders"
        ElseIf MemType = Leader Then
            TempNote = "Lower Leadership"
        Else
            TempNote = "The Grunts"
        End If
        If Arcane > 0.5 Then
            If Brawl > 0.5 Then
                temp = "Rogue"
            Else
                temp = "Wizard"
            End If
        Else
            If Brawl > 0.5 Then
                temp = "Fighter"
            Else
                temp = "Cleric"
            End If
        End If
    Case Town_Militia
        If MemType = Officer Then
            TempNote = "The Commanders"
        ElseIf MemType = Leader Then
            TempNote = "Lower Leadership"
        Else
            TempNote = "The Grunts"
        End If
        If MemType = Officer Then
            If Arcane > 0.9 Then
                If Brawl > 0.6 Then
                    temp = "Rogue"
                Else
                    temp = "Wizard"
                End If
            Else
                If Brawl > 0.3 Then
                    temp = "Fighter"
                Else
                    temp = "Cleric"
                End If
            End If
        ElseIf MemType = Leader Then
            temp = "Fighter"
        Else            'Member
            If Arcane > 0.85 Then
                temp = "Expert"
            ElseIf Arcane > 0.8 Then
                temp = "Rogue"
            ElseIf Arcane > 0.5 Then
                temp = "Fighter"
            Else
                temp = "Commoner"
            End If
        End If
    Case Mercenary
        If MemType = Officer Then
            TempNote = "The Commanders"
        ElseIf MemType = Leader Then
            TempNote = "Lower Leadership"
        Else
            TempNote = "The Grunts"
        End If
        If MemType = Officer Then
            If Arcane > 0.9 Then
                If Brawl > 0.8 Then
                    temp = "Rogue"
                Else
                    temp = "Wizard"
                End If
            Else
                If Brawl > 0.1 Then
                    temp = "Fighter"
                Else
                    temp = "Cleric"
                End If
            End If
        ElseIf MemType = Leader Then
            temp = "Fighter"
        Else            'Member
            If Brawl > 0.4 Then
                temp = "Fighter"
            Else
                temp = "Warrior"
            End If
        End If
    Case OccupationNonGuild
        If MemType = Officer Then
            TempNote = "Masters"
        ElseIf MemType = Leader Then
            TempNote = "Experts"
        Else
            TempNote = "Beginners"
        End If
        If Arcane > 0.5 Then
            If Brawl > 0.5 Then
                temp = "Rogue"
            Else
                temp = "Wizard"
            End If
        Else
            If Brawl > 0.5 Then
                temp = "Fighter"
            Else
                temp = "Cleric"
            End If
        End If
    Case Monster
        If MemType = Officer Then
            TempNote = "Powerful"
        ElseIf MemType = Leader Then
            TempNote = "Mediocre"
        Else
            TempNote = "Fodder"
        End If
        temp = "Monster"
    Case UndeadGroup
        If MemType = Officer Then
            TempNote = "Powerful"
        ElseIf MemType = Leader Then
            TempNote = "Mediocre"
        Else
            TempNote = "Fodder"
        End If
        temp = "Undead Monster"
    End Select

    GetCharClass = temp

End Function

Public Sub RandomizeOfficer(Dude As clsNPC, Index As Integer)

    Dim Arcane, Brawl As Double
    Dim CharClass As String

    Set Dude.Race = m_OrgRace.GetRndRace()
    Dude.Align.Align = m_Align.Align
    
    SetOfficerNotes = False
    If Index = 1 Then
        Dude.CharLevel = m_MaxLevel          'The highest level
        SetOfficerNotes = True
    Else
        Dude.CharLevel = Int(m_MaxLevel * ((Rnd() / 2) + 0.5))   'somewhere in the upper half
    End If

    Arcane = Rnd(1)     'low=clerical, high=wizardly
    Brawl = Rnd(1)      'low=rogueish, high=fighterish
    CharClass = GetCharClass(Arcane, Brawl, Officer)

    Select Case m_Type
    Case Mayor
        Dude.NPCName = "UnNamed Mayor Officer"
        Dude.God = m_God
    Case TownCouncil
        Dude.NPCName = "UnNamed TownCouncil Officer"
        Dude.God = m_God
    Case National_Nobility
        Dude.NPCName = "UnNamed National_Nobility Officer"
        Dude.God = m_God
    Case Local_Nobility
        Dude.NPCName = "UnNamed Local_Nobility Officer"
        Dude.God = m_God
    Case Church
        Dude.NPCName = "UnNamed Church Officer"
        Dude.God = m_God
    Case National_Army
        Dude.NPCName = "UnNamed National_Army Officer"
        Dude.God = m_God
    Case OccupationGuild
        Dude.NPCName = "UnNamed OccupationGuild Officer"
        Dude.God = m_God
    Case Wizard
        Dude.NPCName = "UnNamed Wizard Officer"
        Dude.God = m_God
    Case ExAdventurers
        Dude.NPCName = "UnNamed ExAdventurers Officer"
        Dude.God = m_God
    Case Thieves_Guild
        Dude.NPCName = "UnNamed Thieves_Guild Officer"
        Dude.God = m_God
    Case Local_Army
        Dude.NPCName = "UnNamed Local_Army Officer"
        Dude.God = m_God
    Case Town_Guard
        Dude.NPCName = "UnNamed Town_Guard Officer"
        Dude.God = m_God
    Case Gang
        Dude.NPCName = "UnNamed Gang Officer"
        Dude.God = m_God
    Case Town_Militia
        Dude.NPCName = "UnNamed Town_Militia Officer"
        Dude.God = m_God
    Case Mercenary
        Dude.NPCName = "UnNamed Mercenary Officer"
        Dude.God = m_God
    Case OccupationNonGuild
        Dude.NPCName = "UnNamed OccupationNonGuild Officer"
        Dude.God = m_God
    Case Monster
        Dude.NPCName = "UnNamed Monster Officer"
        Dude.God = m_God
    Case UndeadGroup
        Dude.NPCName = "UnNamed UndeadGroup Officer"
        Dude.God = m_God
    End Select

    Dude.NPCName = Dude.NPCName + ": " + CharClass

    Call RandomizePersonality(Dude)
    
    If SetOfficerNotes = True Then
        m_OfficerNote = TempNote
    End If

End Sub

Public Sub RandomizeLeader(Dude As clsNPC, Index As Integer)

    Dim Arcane, Brawl As Double
    Dim CharClass As String
    Dim PeakLvl As Integer

    Set Dude.Race = m_OrgRace.GetRndRace()
    Dude.Align.Align = m_Align.Align

    SetLeaderNotes = False
    If Index = 1 Then
        SetLeaderNotes = True
    End If
    
    PeakLvl = m_MaxLevel - 1
    If m_Leaders.count > (m_LeaderCnt * 0.4) Then
        PeakLvl = PeakLvl / 2       'allow only 1/2 range on 30%
    ElseIf m_Leaders.count > (m_LeaderCnt * 0.7) Then
        PeakLvl = PeakLvl / 4       'allow only 1/4 range on last 30%
    End If
    If PeakLvl < 1 Then PeakLvl = 1
    Dude.CharLevel = Int(Rnd(1) * PeakLvl) + 1

    Arcane = Rnd(1)     'low=clerical, high=wizardly
    Brawl = Rnd(1)      'low=rogueish, high=fighterish
    CharClass = GetCharClass(Arcane, Brawl, Leader)

    Select Case m_Type
    Case Mayor
        Dude.NPCName = "UnNamed Mayor Leader"
        Dude.God = m_God
    Case TownCouncil
        Dude.NPCName = "UnNamed TownCouncil Leader"
        Dude.God = m_God
    Case National_Nobility
        Dude.NPCName = "UnNamed National_Nobility Leader"
        Dude.God = m_God
    Case Local_Nobility
        Dude.NPCName = "UnNamed Local_Nobility Leader"
        Dude.God = m_God
    Case Church
        Dude.NPCName = "UnNamed Church Leader"
        Dude.God = m_God
    Case National_Army
        Dude.NPCName = "UnNamed National_Army Leader"
        Dude.God = m_God
    Case OccupationGuild
        Dude.NPCName = "UnNamed OccupationGuild Leader"
        Dude.God = m_God
    Case Wizard
        Dude.NPCName = "UnNamed Wizard Leader"
        Dude.God = m_God
    Case ExAdventurers
        Dude.NPCName = "UnNamed ExAdventurers Leader"
        Dude.God = m_God
    Case Thieves_Guild
        Dude.NPCName = "UnNamed Thieves_Guild Leader"
        Dude.God = m_God
    Case Local_Army
        Dude.NPCName = "UnNamed Local_Army Leader"
        Dude.God = m_God
    Case Town_Guard
        Dude.NPCName = "UnNamed Town_Guard Leader"
        Dude.God = m_God
    Case Gang
        Dude.NPCName = "UnNamed Gang Leader"
        Dude.God = m_God
    Case Town_Militia
        Dude.NPCName = "UnNamed Town_Militia Leader"
        Dude.God = m_God
    Case Mercenary
        Dude.NPCName = "UnNamed Mercenary Leader"
        Dude.God = m_God
    Case OccupationNonGuild
        Dude.NPCName = "UnNamed OccupationNonGuild Leader"
        Dude.God = m_God
    Case Monster
        Dude.NPCName = "UnNamed Monster Leader"
        Dude.God = m_God
    Case UndeadGroup
        Dude.NPCName = "UnNamed UndeadGroup Leader"
        Dude.God = m_God
    End Select

    Dude.NPCName = Dude.NPCName + ": " + CharClass

    Call RandomizePersonality(Dude)
    
    If SetLeaderNotes = True Then
        m_LeaderNote = TempNote
    End If

End Sub

Public Sub RandomizeMember(Dude As clsNPC, Index As Integer)

    Dim Arcane, Brawl As Double
    Dim CharClass As String
    Dim PeakLvl As Integer

    Set Dude.Race = m_OrgRace.GetRndRace()
    Dude.Align.Align = m_Align.Align
    
    SetMemberNotes = False
    If Index = 1 Then
        SetMemberNotes = True
    End If
    
    PeakLvl = m_MaxLevel - 2
    If m_Members.count > (m_MemberCnt * 0.2) Then
        PeakLvl = PeakLvl / 2       'allow only 1/2 range on 30%
    ElseIf m_Members.count > (m_MemberCnt * 0.5) Then
        PeakLvl = PeakLvl / 4       'allow only 1/4 range on last 50%
    End If
    If PeakLvl < 1 Then PeakLvl = 1
    Dude.CharLevel = Int(Rnd(1) * PeakLvl) + 1

    Arcane = Rnd(1)     'low=clerical, high=wizardly
    Brawl = Rnd(1)      'low=rogueish, high=fighterish
    CharClass = GetCharClass(Arcane, Brawl, Member)
    
    Select Case m_Type
    Case Mayor
        Dude.NPCName = "UnNamed Mayor Member"
        Dude.God = m_God
    Case TownCouncil
        Dude.NPCName = "UnNamed TownCouncil Member"
        Dude.God = m_God
    Case National_Nobility
        Dude.NPCName = "UnNamed National_Nobility Member"
        Dude.God = m_God
    Case Local_Nobility
        Dude.NPCName = "UnNamed Local_Nobility Member"
        Dude.God = m_God
    Case Church
        Dude.NPCName = "UnNamed Church Member"
        Dude.God = m_God
    Case National_Army
        Dude.NPCName = "UnNamed National_Army Member"
        Dude.God = m_God
    Case OccupationGuild
        Dude.NPCName = "UnNamed OccupationGuild Member"
        Dude.God = m_God
    Case Wizard
        Dude.NPCName = "UnNamed Wizard Member"
        Dude.God = m_God
    Case ExAdventurers
        Dude.NPCName = "UnNamed ExAdventurers Member"
        Dude.God = m_God
    Case Thieves_Guild
        Dude.NPCName = "UnNamed Thieves_Guild Member"
        Dude.God = m_God
    Case Local_Army
        Dude.NPCName = "UnNamed Local_Army Member"
        Dude.God = m_God
    Case Town_Guard
        Dude.NPCName = "UnNamed Town_Guard Member"
        Dude.God = m_God
    Case Gang
        Dude.NPCName = "UnNamed Gang Member"
        Dude.God = m_God
    Case Town_Militia
        Dude.NPCName = "UnNamed Town_Militia Member"
        Dude.God = m_God
    Case Mercenary
        Dude.NPCName = "UnNamed Mercenary Member"
        Dude.God = m_God
    Case OccupationNonGuild
        Dude.NPCName = "UnNamed OccupationNonGuild Member"
        Dude.God = m_God
    Case Monster
        Dude.NPCName = "UnNamed Monster Member"
        Dude.God = m_God
    Case UndeadGroup
        Dude.NPCName = "UnNamed UndeadGroup Member"
        Dude.God = m_God
    End Select

    Dude.NPCName = Dude.NPCName + ": " + CharClass

    Call RandomizePersonality(Dude)
    
    If SetMemberNotes = True Then
        m_MemberNote = TempNote
    End If

End Sub
