VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPantheon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private m_Dwarf As clsRaceAlignSet
Private m_Elf As clsRaceAlignSet
Private m_Gnome As clsRaceAlignSet
Private m_Halfling As clsRaceAlignSet
Private m_HalfOrc As clsRaceAlignSet
Private m_Human As clsRaceAlignSet
Private m_HalfElf As clsRaceAlignSet
Private m_Name As String

Public Property Let PanName(ByVal vData As String)

    m_Name = vData

End Property

Public Property Get PanName() As String

    PanName = m_Name

End Property

Public Property Set HalfElfPan(ByVal vData As clsRaceAlignSet)
    
    Set m_HalfElf = vData

End Property

Public Property Get HalfElfPan() As clsRaceAlignSet
    
    Set HalfElfPan = m_HalfElf

End Property

Public Property Set HumanPan(ByVal vData As clsRaceAlignSet)
    
    Set m_Human = vData

End Property

Public Property Get HumanPan() As clsRaceAlignSet
    
    Set HumanPan = m_Human

End Property

Public Property Set HalfOrcPan(ByVal vData As clsRaceAlignSet)
    
    Set m_HalfOrc = vData

End Property

Public Property Get HalfOrcPan() As clsRaceAlignSet
    
    Set HalfOrcPan = m_HalfOrc

End Property

Public Property Set HalflingPan(ByVal vData As clsRaceAlignSet)
    
    Set m_Halfling = vData

End Property

Public Property Get HalflingPan() As clsRaceAlignSet
    
    Set HalflingPan = m_Halfling

End Property

Public Property Set GnomePan(ByVal vData As clsRaceAlignSet)
    
    Set m_Gnome = vData

End Property

Public Property Get GnomePan() As clsRaceAlignSet
    
    Set GnomePan = m_Gnome

End Property

Public Property Set ElfPan(ByVal vData As clsRaceAlignSet)
    
    Set m_Elf = vData

End Property

Public Property Get ElfPan() As clsRaceAlignSet
    
    Set ElfPan = m_Elf

End Property

Public Property Set DwarfPan(ByVal vData As clsRaceAlignSet)
    
    Set m_Dwarf = vData

End Property

Public Property Get DwarfPan() As clsRaceAlignSet
    
    Set DwarfPan = m_Dwarf

End Property

Public Function GetRandomGod(tAlign As clsAlign, tRace As clsOrgRaceDist) As String

    Dim GodName As String
    Dim temp As clsRace
    
    Set temp = tRace.GetPluralityRace

    Select Case temp.RaceEnum
    
    Case Elf:                                           'Elf
        GodName = m_Elf.GetRandomGod(tAlign)
    Case Dwarf:                                         'Dwarf
        GodName = m_Dwarf.GetRandomGod(tAlign)
    Case Human:                                         'Human
        GodName = m_Human.GetRandomGod(tAlign)
    Case Halfling:                                      'Halfling
        GodName = m_Halfling.GetRandomGod(tAlign)
    Case HalfElf:                                       'HalfElf
        GodName = m_HalfElf.GetRandomGod(tAlign)
    Case HalfOrc:                                       'HalfOrc
        GodName = m_HalfOrc.GetRandomGod(tAlign)
    Case Gnome:                                         'Gnome
        GodName = m_Gnome.GetRandomGod(tAlign)
    End Select
    
    GetRandomGod = GodName

End Function

Public Function GetAllGodNames() As Collection

    Dim temp As clsRaceAlignSet
    Dim Align As clsAlign
    Dim LocalGodName, junk As String
    Dim RaceAlignGroup As clsGodsFrequencies
    Dim AllGodNames, NameList As Collection
    Dim I, K As Integer
    Dim J As Alignment
    Dim Found As Boolean
    
    Found = False
    Set Align = New clsAlign
    Set temp = New clsRaceAlignSet
    Set AllGodNames = New Collection
    Set NameList = New Collection
        
    For I = 1 To 7
    
        Select Case I
        Case 1:
            Set temp = m_Dwarf
        Case 2:
            Set temp = m_Elf
        Case 3:
            Set temp = m_Gnome
        Case 4:
            Set temp = m_Halfling
        Case 5:
            Set temp = m_HalfOrc
        Case 6:
            Set temp = m_Human
        Case 7:
            Set temp = m_HalfElf
        End Select
        For J = LawfulGood To ChaoticEvil Step NeutralGood
            Align.Align = J
            Set NameList = temp.Gods(Align).GodName
            For Each LocalGodName In NameList
                If AllGodNames.count > 0 Then
                    For K = 1 To AllGodNames.count
                        If AllGodNames.Item(K) = LocalGodName Then
                            Found = True
                            Exit For
                        End If
                    Next K
                End If
                If Found = False Then
                    Call AllGodNames.Add(LocalGodName)
                Else
                    Found = False
                End If
            Next
            Set NameList = Nothing
        Next J
        Set temp = Nothing
    Next I

    Set GetAllGodNames = AllGodNames

End Function

Private Sub Class_Initialize()

    Set m_Dwarf = New clsRaceAlignSet
    m_Dwarf.Race.RaceEnum = Dwarf
    
    Set m_Elf = New clsRaceAlignSet
    m_Elf.Race.RaceEnum = Elf
    
    Set m_Gnome = New clsRaceAlignSet
    m_Gnome.Race.RaceEnum = Gnome
    
    Set m_Halfling = New clsRaceAlignSet
    m_Halfling.Race.RaceEnum = Halfling
    
    Set m_HalfOrc = New clsRaceAlignSet
    m_HalfOrc.Race.RaceEnum = HalfOrc
    
    Set m_Human = New clsRaceAlignSet
    m_Human.Race.RaceEnum = Human
    
    Set m_HalfElf = New clsRaceAlignSet
    m_HalfElf.Race.RaceEnum = HalfElf

End Sub
