VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPantheons"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private m_Pantheons As Collection

Public Property Set Pantheon(ByVal vData As Collection)
    
    Set m_Pantheons = vData

End Property

Public Property Get Pantheon() As Collection
Attribute Pantheon.VB_UserMemId = 0
    
    Set Pantheon = m_Pantheons

End Property

Private Function ReadDietyFile()

    Dim I, J, C, OldC, P, GodFreq, F, N As Integer
    Dim Lines() As String
    Dim S, GodName, RaceName As String
    Dim temp As clsRaceGroup
    Dim Align As clsAlign
    
    J = 0: I = 0
    ReDim Lines(1)
    Set Align = New clsAlign
    
    F = FreeFile()
    Open ".\Diety Info.txt" For Input As F
    Do While (Not EOF(F))
        S = Left$(Lines(I), 1)
        If S <> "'" And Len(Lines(I)) > 1 Then
            I = I + 1
            ReDim Preserve Lines(I)
            If S = "[" Then N = N + 1
        End If
        Line Input #F, Lines(I)
    Loop
    Close F
    
    NewPantheon = True
    
    For P = 1 To N
        Set temp = New clsRaceGroup
        temp.PanName = Mid$(Lines(J), 2, Len(Lines(J)) - 2)
        J = J + 1
        Do While ((Left$(Lines(J), 1) <> "[") And (J < I))
            C = 0
            OldC = 1
            C = InStr(OldC, Lines(J), ",")
            RaceName = Left$(Lines(J), C)
            OldC = C + 1
            C = InStr(OldC, Lines(J), ",")
            Align.Align = Align.GetAlignIndex(Mid$(Lines(J), OldC, C - OldC))
            OldC = C + 1
            C = InStr(OldC, Lines(J), ",")
            GodName = Mid$(Lines(J), OldC, C - OldC)
            GodFreq = Mid$(Lines(J), C + 1, Len(Lines(J)) - (C + 1))
            
            Select Case RaceName
            Case "Dwarf":
                Call temp.DwarfPan.AddGod(Align, GodName, GodFreq)
            Case "Elf":
                Call temp.ElfPan.AddGod(Align, GodName, GodFreq)
            Case "Gnome":
                Call temp.GnomePan.AddGod(Align, GodName, GodFreq)
            Case "Halfling":
                Call temp.HalflingPan.AddGod(Align, GodName, GodFreq)
            Case "HalfOrc":
                Call temp.HalfOrcPan.AddGod(Align, GodName, GodFreq)
            Case "Human":
                Call temp.HumanPan.AddGod(Align, GodName, GodFreq)
            Case "HalfElf":
                Call temp.HalfElfPan.AddGod(Align, GodName, GodFreq)
            End Select
            
            J = J + 1
        Loop
        Call m_Pantheons.Add(temp)
        Set temp = Nothing
    Next P
    Set Align = Nothing

End Function

Private Sub Class_Initialize()

    Set m_Pantheons = New Collection
    Call ReadDietyFile

End Sub
