VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsRaceAlignSet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"clsGodsFrequencies"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private m_LG As clsGodsFrequencies
Private m_NG As clsGodsFrequencies
Private m_CG As clsGodsFrequencies
Private m_LN As clsGodsFrequencies
Private m_N As clsGodsFrequencies
Private m_CN As clsGodsFrequencies
Private m_LE As clsGodsFrequencies
Private m_NE As clsGodsFrequencies
Private m_CE As clsGodsFrequencies

Private m_Race As clsRace

Public Property Let Race(ByVal vData As clsRace)
    
    Set m_Race = vData

End Property

Public Property Get Race() As clsRace
    
    Set Race = m_Race

End Property

Friend Function GetRandomGod(tAlign As clsAlign) As String

    Dim temp As String

    Select Case tAlign.Align
    
    Case LawfulGood:
        temp = m_LG.GetRandomGod()
    Case NeutralGood:
        temp = m_NG.GetRandomGod()
    Case ChaoticGood:
        temp = m_CG.GetRandomGod()
    Case LawfulNeutral:
        temp = m_LN.GetRandomGod()
    Case TrueNeutral:
        temp = m_N.GetRandomGod()
    Case ChaoticNeutral:
        temp = m_CN.GetRandomGod()
    Case LawfulEvil:
        temp = m_LE.GetRandomGod()
    Case NeutralEvil:
        temp = m_NE.GetRandomGod()
    Case ChaoticEvil:
        temp = m_CE.GetRandomGod()
    End Select
    
    GetRandomGod = temp

End Function

Public Sub Clear(Align As clsAlign)

    Select Case Align.Align
    
    Case LawfulGood:
        Set m_LG = Nothing
        Set m_LG = New clsGodsFrequencies
    Case NeutralGood:
        Set m_NG = Nothing
        Set m_NG = New clsGodsFrequencies
    Case ChaoticGood:
        Set m_CG = Nothing
        Set m_CG = New clsGodsFrequencies
    Case LawfulNeutral:
        Set m_LN = Nothing
        Set m_LN = New clsGodsFrequencies
    Case TrueNeutral:
        Set m_N = Nothing
        Set m_N = New clsGodsFrequencies
    Case ChaoticNeutral:
        Set m_CN = Nothing
        Set m_CN = New clsGodsFrequencies
    Case LawfulEvil:
        Set m_LE = Nothing
        Set m_LE = New clsGodsFrequencies
    Case NeutralEvil:
        Set m_NE = Nothing
        Set m_NE = New clsGodsFrequencies
    Case ChaoticEvil:
        Set m_CE = Nothing
        Set m_CE = New clsGodsFrequencies
    End Select

End Sub

Public Sub Remove(Align As clsAlign, GodName As String)

    Dim temp As clsGodsFrequencies
    Dim I As Integer

    Select Case Align.Align
    
    Case LawfulGood:
        Set temp = m_LG
    Case NeutralGood:
        Set temp = m_LG
    Case ChaoticGood:
        Set temp = m_LG
    Case LawfulNeutral:
        Set temp = m_LG
    Case TrueNeutral:
        Set temp = m_LG
    Case ChaoticNeutral:
        Set temp = m_LG
    Case LawfulEvil:
        Set temp = m_LG
    Case NeutralEvil:
        Set temp = m_LG
    Case ChaoticEvil:
        Set temp = m_LG
    End Select

    For I = 1 To temp.GodName.count
        If temp.GodName.Item(I) = GodName Then
            Call temp.GodName.Remove(I)
            Exit For
        End If
    Next
    Call temp.Frequency.Remove(GodName)

End Sub

Public Sub AddGod(ByVal Align As clsAlign, ByVal GodName As String, ByVal GodFreq As Integer)

    Dim temp As clsGodsFrequencies
    
    Select Case Align.Align
    
    Case LawfulGood:
        Set temp = m_LG
    Case NeutralGood:
        Set temp = m_NG
    Case ChaoticGood:
        Set temp = m_CG
    Case LawfulNeutral:
        Set temp = m_LN
    Case TrueNeutral:
        Set temp = m_N
    Case ChaoticNeutral:
        Set temp = m_CN
    Case LawfulEvil:
        Set temp = m_LE
    Case NeutralEvil:
        Set temp = m_NE
    Case ChaoticEvil:
        Set temp = m_CE
    End Select

    If temp.Updated = False Then
        Call temp.GodName.Remove(1)
        Call temp.Frequency.Remove(1)
        temp.Updated = True
    End If
    Call temp.GodName.Add(GodName)
    Call temp.Frequency.Add(GodFreq, GodName)

End Sub

Private Sub Class_Initialize()
    
    Dim GodName As String
    Dim GodFreq As Integer
    
    GodFreq = 100
    
    Set m_LG = New clsGodsFrequencies
    GodName = "Generic LG God"
    m_LG.GodName.Add GodName
    m_LG.Frequency.Add GodFreq, "Generic LG God"
    m_LG.Updated = False
    
    Set m_NG = New clsGodsFrequencies
    GodName = "Generic NG God"
    m_NG.GodName.Add GodName
    m_NG.Frequency.Add GodFreq, "Generic NG God"
    m_NG.Updated = False
    
    Set m_CG = New clsGodsFrequencies
    GodName = "Generic CG God"
    m_CG.GodName.Add GodName
    m_CG.Frequency.Add GodFreq, "Generic CG God"
    m_CG.Updated = False
    
    Set m_LN = New clsGodsFrequencies
    GodName = "Generic LN God"
    m_LN.GodName.Add GodName
    m_LN.Frequency.Add GodFreq, "Generic LN God"
    m_LN.Updated = False
    
    Set m_N = New clsGodsFrequencies
    GodName = "Generic N God"
    m_N.GodName.Add GodName
    m_N.Frequency.Add GodFreq, "Generic N God"
    m_N.Updated = False
    
    Set m_CN = New clsGodsFrequencies
    GodName = "Generic CN God"
    m_CN.GodName.Add GodName
    m_CN.Frequency.Add GodFreq, "Generic CN God"
    m_CN.Updated = False
    
    Set m_LE = New clsGodsFrequencies
    GodName = "Generic LE God"
    m_LE.GodName.Add GodName
    m_LE.Frequency.Add GodFreq, "Generic LE God"
    m_LE.Updated = False
    
    Set m_NE = New clsGodsFrequencies
    GodName = "Generic NE God"
    m_NE.GodName.Add GodName
    m_NE.Frequency.Add GodFreq, "Generic NE God"
    m_NE.Updated = False
    
    Set m_CE = New clsGodsFrequencies
    GodName = "Generic CE God"
    m_CE.GodName.Add GodName
    m_CE.Frequency.Add GodFreq, "Generic CE God"
    m_CE.Updated = False

    Set m_Race = New clsRace

End Sub

Public Property Get Gods(Align As clsAlign) As clsGodsFrequencies
    
    Select Case Align.Align
    
    Case LawfulGood:
        Set Gods = m_LG
    Case NeutralGood:
        Set Gods = m_NG
    Case ChaoticGood:
        Set Gods = m_CG
    Case LawfulNeutral:
        Set Gods = m_LN
    Case TrueNeutral:
        Set Gods = m_N
    Case ChaoticNeutral:
        Set Gods = m_CN
    Case LawfulEvil:
        Set Gods = m_LE
    Case NeutralEvil:
        Set Gods = m_NE
    Case ChaoticEvil:
        Set Gods = m_CE
    End Select

End Property

Public Property Set Gods(Align As clsAlign, vData As clsGodsFrequencies)
    
    Select Case Align.Align
    
    Case LawfulGood:
        Set m_LG = vData
    Case NeutralGood:
        Set m_NG = vData
    Case ChaoticGood:
        Set m_CG = vData
    Case LawfulNeutral:
        Set m_LN = vData
    Case TrueNeutral:
        Set m_N = vData
    Case ChaoticNeutral:
        Set m_CN = vData
    Case LawfulEvil:
        Set m_LE = vData
    Case NeutralEvil:
        Set m_NE = vData
    Case ChaoticEvil:
        Set m_CE = vData
    End Select

End Property

Private Sub Class_Terminate()
    
    Set m_LG = Nothing
    Set m_NG = Nothing
    Set m_CG = Nothing
    Set m_LN = Nothing
    Set m_N = Nothing
    Set m_CN = Nothing
    Set m_LE = Nothing
    Set m_NE = Nothing
    Set m_CE = Nothing

    Set m_Race = Nothing

End Sub
