VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmSurroundings 
   Caption         =   "Step 2 of 9 - Assign Town Surroundings & Physical Attributes"
   ClientHeight    =   5475
   ClientLeft      =   6630
   ClientTop       =   4875
   ClientWidth     =   5940
   ControlBox      =   0   'False
   Icon            =   "frmSurroundings.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   365
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   396
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdPrevious 
      Caption         =   "<- PREV"
      Height          =   495
      Left            =   1650
      TabIndex        =   16
      ToolTipText     =   "Return to the previous screen, if you change something on the previous screen it will NOT automatically update this screen."
      Top             =   4725
      Width           =   1215
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "NEXT ->"
      Height          =   495
      Left            =   3075
      TabIndex        =   12
      ToolTipText     =   "Go on the the next screen."
      Top             =   4725
      Width           =   1215
   End
   Begin VB.CommandButton cmdRandomAll 
      Caption         =   "Random ALL"
      Height          =   495
      Left            =   3975
      TabIndex        =   11
      ToolTipText     =   "Randomize all the controls on this screen."
      Top             =   360
      Width           =   1650
   End
   Begin VB.CheckBox chkRiver 
      Caption         =   "On River?"
      Height          =   255
      Left            =   4185
      TabIndex        =   1
      ToolTipText     =   "Is the settlement on the shore of a river?"
      Top             =   2400
      Width           =   1215
   End
   Begin VB.CheckBox chkCoastal 
      Caption         =   "Coastal?"
      Height          =   255
      Left            =   4185
      TabIndex        =   0
      ToolTipText     =   "Is the settlement on the coast of an ocean or lake?"
      Top             =   1920
      Width           =   1095
   End
   Begin MSComctlLib.Slider sldTemp 
      Height          =   390
      HelpContextID   =   10
      Left            =   270
      TabIndex        =   2
      ToolTipText     =   "General temperature level of the area around the settlement."
      Top             =   735
      Width           =   2175
      _ExtentX        =   3836
      _ExtentY        =   688
      _Version        =   393216
      Max             =   100
      SelStart        =   50
      TickFrequency   =   10
      Value           =   50
   End
   Begin MSComctlLib.Slider sldPrecip 
      Height          =   390
      HelpContextID   =   10
      Left            =   270
      TabIndex        =   5
      ToolTipText     =   "General level of precipitation of the area around the settlement."
      Top             =   1620
      Width           =   2175
      _ExtentX        =   3836
      _ExtentY        =   688
      _Version        =   393216
      Max             =   100
      SelStart        =   50
      TickFrequency   =   10
      Value           =   50
   End
   Begin MSComctlLib.Slider sldTerrain 
      Height          =   390
      HelpContextID   =   10
      Left            =   270
      TabIndex        =   8
      ToolTipText     =   "How rugged the terrain is in the surrounding countryside."
      Top             =   2430
      Width           =   2175
      _ExtentX        =   3836
      _ExtentY        =   688
      _Version        =   393216
      Max             =   100
      SelStart        =   50
      TickFrequency   =   10
      Value           =   50
   End
   Begin MSComctlLib.Slider sldTameness 
      Height          =   390
      HelpContextID   =   10
      Left            =   270
      TabIndex        =   13
      ToolTipText     =   "The level of civilization in the surrounding countryside."
      Top             =   3675
      Width           =   2175
      _ExtentX        =   3836
      _ExtentY        =   688
      _Version        =   393216
      Max             =   100
      SelStart        =   50
      TickFrequency   =   10
      Value           =   50
   End
   Begin VB.Label lblTamenessScale 
      Caption         =   "Civilized        Frontier          Wild"
      Height          =   255
      Index           =   0
      Left            =   195
      TabIndex        =   15
      Top             =   4125
      Width           =   2355
   End
   Begin VB.Label lblTameness 
      Caption         =   "Tameness"
      Height          =   255
      Index           =   0
      Left            =   2430
      TabIndex        =   14
      Top             =   3675
      Width           =   855
   End
   Begin VB.Label lblTerrain 
      Caption         =   "Terrain"
      Height          =   255
      Index           =   0
      Left            =   2430
      TabIndex        =   10
      Top             =   2430
      Width           =   975
   End
   Begin VB.Label lblTerrainScale 
      Caption         =   "Flat              Hills         Mountains"
      Height          =   255
      Index           =   1
      Left            =   330
      TabIndex        =   9
      Top             =   2850
      Width           =   2565
   End
   Begin VB.Label lblPrecip 
      Caption         =   "Precipitation"
      Height          =   255
      Index           =   1
      Left            =   2430
      TabIndex        =   7
      Top             =   1620
      Width           =   975
   End
   Begin VB.Label lblPrecipScale 
      Caption         =   "Dry              Avg             Wet"
      Height          =   255
      Index           =   0
      Left            =   345
      TabIndex        =   6
      Top             =   2025
      Width           =   2160
   End
   Begin VB.Label lblTemp 
      Caption         =   "Temperature"
      Height          =   255
      Index           =   5
      Left            =   2430
      TabIndex        =   4
      Top             =   735
      Width           =   975
   End
   Begin VB.Label lblTempScale 
      Caption         =   "Cold          Moderate         Hot"
      Height          =   255
      Index           =   6
      Left            =   285
      TabIndex        =   3
      Top             =   1200
      Width           =   2310
   End
End
Attribute VB_Name = "frmSurroundings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub chkCoastal_Click()

    If chkCoastal.value = Checked Then
        newtown.Areas.Coastal = True
    Else
        newtown.Areas.Coastal = False
    End If

End Sub

Private Sub chkCoastal_Validate(Cancel As Boolean)

    If chkCoastal.value = Checked Then
        newtown.Areas.Coastal = True
    Else
        newtown.Areas.Coastal = False
    End If

End Sub

Private Sub chkRiver_Click()

    If chkRiver.value = Checked Then
        newtown.Areas.River = True
    Else
        newtown.Areas.River = False
    End If

End Sub

Private Sub chkRiver_Validate(Cancel As Boolean)

    If chkRiver.value = Checked Then
        newtown.Areas.River = True
    Else
        newtown.Areas.River = False
    End If

End Sub

Private Sub cmdNext_Click()

    frmCampGovt.Show
    frmSurroundings.Visible = False

End Sub

Private Sub cmdPrevious_Click()

    frmStart.Visible = True
    frmSurroundings.Visible = False

End Sub

Private Sub cmdRandomAll_Click()

    sldTemp.value = Int(Rnd(1) * 101)
    sldPrecip.value = Int(Rnd(1) * 101)
    sldTerrain.value = Int(Rnd(1) * 101)
    sldTameness.value = Int((Rnd(1) * 11) + (Rnd(1) * 90) - (Rnd(1) * 30))
    
    If (Rnd(1) < 0.5) Then
        chkCoastal.value = Checked
    Else
        chkCoastal.value = Unchecked
    End If
    
    If (Rnd(1) < 0.5) Then
        chkRiver.value = Checked
    Else
        chkRiver.value = Unchecked
    End If

End Sub

Private Sub Form_Load()

    Call cmdRandomAll_Click

End Sub

Private Sub sldPrecip_Change()

    newtown.Areas.Precip = sldPrecip.value

End Sub

Private Sub sldTameness_Change()

    newtown.Areas.Tameness = sldTameness.value

End Sub

Private Sub sldTemp_Change()

    newtown.Areas.temp = sldTemp.value

End Sub

Private Sub sldTerrain_Change()

    newtown.Areas.Terrain = sldTerrain.value

End Sub
